#!/bin/sh

# save.sh:  create 'release tarball' of ntm-51
#
# To save a new release:
#   Make a new save.sh file - do a global replace of
#     DIR with the release name, e.g. NeTraMet51
#
# save.sh  51b16         # save ~/ntm-51 to NeTraMet51b16.tar.gz
# save.sh  cvs NeTraMet  # save ./NeTraMet to cvs.tar.gz


dir=~/ntm-51

if [ $# -eq 0 ]; then
   echo No args given, save ~/ntm-51 to NeTraMet.tar.gz
   tarfn='NeTraMet'
else
   if [ $# -eq 1 ]; then
      tarfn="NeTraMet$1"
   else
      tarfn=$1
      dir=$2
      fi
   fi

echo "save $dir to $tarfn.tar.gz"

mv $dir $tarfn

#mv $dir NeTraMet51b15  # Thu, 16 Feb 06 (PST)
#mv $dir NeTraMet51b14  # Thu, 18 Jan 06 (NZDT)
#mv $dir NeTraMet51b13  # Mon, 19 Dec 05 (NZDT)
#mv $dir NeTraMet51b12  # Thu,  3 Nov 05 (PST)
#mv $dir NeTraMet51b11  # Wed,  2 Nov 05 (PST)
#mv $dir NeTraMet51b10  # Fri, 22 Jul 05 (NZST)
#mv $dir NeTraMet51b9   # Mon, 16 May 05 (NZST)
#mv $dir NeTraMet51b8   # Tue, 22 Mar 05 (PST)
# mv $dir NeTraMet51b7  # Wed, 16 Mar 05 (PST)

rm $tarfn.tar.gz
rm $tarfn/src/*/*~ $tarfn/src/bgp/*/*~
rm $tarfn/*~
rm $tarfn/#*

tar -cf $tarfn.tar \
   $tarfn/*in $tarfn/*/*in $tarfn/*/*/*in \
   $tarfn/README $tarfn/*.txt \
   $tarfn/*.sh $tarfn/etc/install-sh \
   $tarfn/etc/config.sub $tarfn/etc/config.guess \
   $tarfn/doc/NeTraMet/*ice $tarfn/doc/NeTraMet/*ory \
   $tarfn/doc/NeTraMet/*.txt $tarfn/doc/NeTraMet/*.html \
   $tarfn/doc/NeTraMet/*.srl $tarfn/doc/NeTraMet/*.rb \
   $tarfn/doc/snmp/HIS* $tarfn/doc/snmp/*.snmp \
   $tarfn/doc/snmp/READ* $tarfn/doc/snmp/exclude \
   $tarfn/doc/snmp/snmp* $tarfn/doc/snmp/var* \
   $tarfn/examples/*.srl $tarfn/examples/non-srl/rules.* \
   $tarfn/lib/*.pm \
   $tarfn/mib/*.txt $tarfn/mib/*.auckland \
   $tarfn/pc/*.txt $tarfn/pc/*.cfg \
   $tarfn/INSTALL $tarfn/configure \
   $tarfn/src/*/README* \
   $tarfn/src/*/*.c $tarfn/src/*/*.cpp $tarfn/src/*/*.h \
   $tarfn/src/bgp/*/*.c $tarfn/src/bgp/*/*.h \
   $tarfn/src/meter/tcpdump/*.h $tarfn/src/meter/tcpdump/net/*.h \
   $tarfn/src/meter/threads/*.h $tarfn/src/meter/threads/*.c \
   $tarfn/src/meter/threads/Makefile

gzip $tarfn.tar

mv $tarfn $dir


#
# $Log: save.sh,v $
# Revision 1.6  2006/03/22 16:39:13  nevil
# 51b16:
#    Added config.sub from autoconf259 to etc; ./configure now recognises amd64
#    Fixed bad DNS_RECSZ values; set delta_OK = 0 when ignoring records
#       with payload_len == 0
#    Added nested #defines to trace DNS_RECSZ for TCP or TCP+UDP records
#
# Revision 1.5  2006/03/21 22:20:06  nevil
# Put CVS headers into ntm_conf and Makefile .in
#
# Revision 1.4  2006/03/21 21:48:54  nevil
# Generalise save.sh using command-line arguments
#
# Revision 1.3  2006/03/21 20:39:13  nevil
# another test
#
