/* 1400, Tue 30 Jan 03 (NZDT)

   FD_CHECK_DEFS: Checks that fd_data.h declares the attributes
                  properly, and that we haven't accidentally
                  re-used any attribute numbers.

   Copyright (C) 1994-2006 by Nevil Brownlee
   University of Auckland | CAIDA */

#if HAVE_CONFIG_H
#include <ntm_conf.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>  /* u_char etc. */

#define EXTERN

#include "ausnmp.h"
#include "asn1.h"

#include "fd_data.h"

int sort_cmp(const void *a, const void *b)
{
   const struct attrib_info *ap = a, *bp = b;
   if (ap->index < bp->index)
      return -1;
   else if (ap->index == bp->index)
      return 0;
   else return 1;
   }

int main(int argc, char *argv[])
{
   struct attrib_info *ai;
   int j, nu;
   char used[1+LASTATTRIB];

   printf("fd_check_defs: checks attribute number definitions\n\n");

   printf("N_NEW_BASIC   = %4d\n", N_NEW_BASIC);
   printf("N_RATE_ATRS   = %4d\n", N_RATE_ATRS);
   printf("N_OLD_ATRS    = %4d\n\n",  N_OLD_ATRS);

   printf("N_DIST_ATRS   = %4d\n", N_DIST_ATRS);
   printf("N_DIST2_ATRS  = %4d\n", N_DIST2_ATRS);
   printf("N_EXT_ATRS    = %4d (includes distrib2 attribs)\n\n", N_EXT_ATRS);

   printf("N_ATTRIBS     = %4d\n", N_ATTRIBS);
   printf("N_SYNONYMS    = %4d\n", N_SYNONYMS);
   printf("SZ_ATTRIBS    = %4d\n\n",SZ_ATTRIBS );

   printf("LASTATTRIB   = %4d\n\n", LASTATTRIB);
   printf("\n");

   memset(used, 0, sizeof(used));
   qsort(attribs, SZ_ATTRIBS,sizeof(struct attrib_info), sort_cmp);
   for (nu = j = 0; j != SZ_ATTRIBS; ++j) {
      ai = &attribs[j];
      printf("%4d: %22s %4d", j, ai->name,ai->index);
      if (used[ai->index]) {
         ++nu;  printf("  <-- used\n");
         }
      else printf("\n");
      used[ai->index] = 1;
      }
   printf("\n");
   if (nu != N_SYNONYMS) printf(
      "   >>>>> ERROR: %d multiply-used attribute numbers <<<<<\n\n",
      nu);

   if ((DELTA_DISTRIB_BASE-DISTRIB_BASE) != (DELTA_DISTRIB_BASE-DISTRIB_BASE))
     printf("\n\n(DELTA_DISTRIB_BASE=%d, DISTRIB_BASE=%d,  \n"
        "DELTA_DISTRIB2_BASE=%d, DISTRIB2_BASE=%d\n\n",
        DELTA_DISTRIB_BASE,DISTRIB_BASE, DELTA_DISTRIB2_BASE,DISTRIB_BASE);
   }
