/* 1000, Mon 2 Jan 05 (NZDT)

   METER_UX.C:  The AU Internet Accouting Meter mainline

   Copyright (C) 1992-2006 by Nevil Brownlee,
   CAIDA | University of Auckland */

/*  51b9 has preliminary work on the following:
      NO_MERGE_THREAD patches tried (in 1.5 days work) with DAG cards
      at U Wisc, Madison, March 05.  Make dd_ntm_nm, no global define
      for NO_MERGE_THREAD, not implemented for libpcap. */
                                                        
/*
 * $Log: meter_ux.c,v $
 * Revision 1.3  2006/03/30 04:35:43  nevil
 * libpcap: test whether source is a file, only call pcap_open_live()
 *   if it's not.  That way we don't need su privilege to read a pacp file.
 * Implement -E flag to say "don't require req/response match" for
 *   DNS datagrams
 * Implement -Znnn flag to log DNS records > nnn bytes
 * Set payload_len for UDP packets to wire length - encapsulation
 *   headers - IP header.  UDPlen field in UDP header isn't always
 *   set correctly!
 *
 * Revision 1.2  2006/03/27 02:53:30  nevil
 * Updates to 51b16, on way home from IETF65
 *
 * Revision 1.1.1.2  2006/03/21 18:08:53  nevil
 * Version 5.1b15
 *
 * Revision 1.1.1.2.2.19  2002/10/31 23:02:37  nevil
 * 45b8: fd_filter 'tail' option implemented, \t supported as format separator
 *
 * Revision 1.1.1.2.2.18  2002/09/13 15:05:29  nevil
 * Implement VLANid, Priority and ECNCodeBits attributes
 *
 * Revision 1.1.1.2.2.17  2002/08/27 17:13:19  nevil
 * Improve thread locking.  Implement STREAM_TO_FLOW, ECNBits and TCPStreamData
 *
 * Revision 1.1.1.2.2.16  2002/07/03 01:45:55  nevil
 * Implement OAM attributes
 *
 * Revision 1.1.1.2.2.15  2002/06/30 01:08:04  nevil
 * Make *Interface attribs 16-bit (instead of 8)
 *
 * Revision 1.1.1.2.2.14  2002/06/29 01:55:57  nevil
 * Miscellaneous fixes for warnings found by Compaq Unix cc
 *
 * Revision 1.1.1.2.2.10  2001/06/07 05:33:41  nevil
 * Fork daemon before starting interface(s).
 * Linux 2.2.19 kernel reset promiscuous mode at the fork!
 *
 * Revision 1.1.1.2.2.9  2001/05/24 02:19:56  nevil
 * LfapMet implemented by Remco Poortinga.
 * MinPDUs implemented by Nevil.
 *
 * Revision 1.1.1.2.2.6  2000/08/08 19:44:53  nevil
 * 44b8 release
 *
 * Revision 1.1.1.2.2.4  2000/06/06 03:38:22  nevil
 * Combine NEW_ATR with TCP_ATR, various bug fixes
 *
 * Revision 1.1.1.2.2.1  2000/01/12 02:57:12  nevil
 * Implement 'packet pair matched' turnaroundtime distribution attributes.
 * Fix ASN-related bugs in NeTraMet, distribution-related bugs in fd_filter.
 *
 * Revision 1.1.1.2  1999/10/03 21:06:26  nevil
 * *** empty log message ***
 *
 * Revision 1.1.1.1.2.14  1999/09/29 22:29:15  nevil
 * Changes (mainly changing // to /* comments) for Irix
 *
 * Revision 1.1.1.1.2.13  1999/09/22 05:38:43  nevil
 * Improve code to work properly on 64-bit machines
 * - Add OS=ALPHA handling to configure.in
 * - Clean up the Alpha compiler warnings
 * - Change all the snmp-related code to use Bit32 instead of unsigned long
 *
 * Revision 1.1.1.1.2.12  1999/09/14 00:45:29  nevil
 * 4.3 Release ..
 *  - Implement -D option to run NeTraMet as a daemon
 *  - Tidy up the on-line help displays
 *
 * Revision 1.1.1.1.2.11  1999/05/26 02:41:41  nevil
 * Integrate V6 and ASN code into PC versions of the meter.
 * This required a rework of the makefiles, using @cflags.opt files
 * to provide a much longer command line to the Borland C compiler.
 *
 * Revision 1.1.1.1.2.10  1999/05/17 00:11:58  nevil
 * Fixed 'reuse of ruleset row' problem:
 *   When a ruleset row is destroyed, set_RowStatus calls free_rulespace()
 *   and recover_flows().  free_rulespace() zeroed its varibales in the
 *   ri[] row, but recover_flows() didn't (it should have zeroed
 *   ri_flow_chain).  This left ri_flow_chain pointing to a free flow,
 *   which cause problems if a manager tried to reuse this row for a
 *   new ruleset.  Fixed by zeroing all of the ri[] row. (Also commented
 *   out the zeroing code from free_rulesace).
 *
 * Revision 1.1.1.1.2.9  1999/04/20 04:45:59  nevil
 * Add some checking to handle_keyboard() so as to prevent it from
 * trying to process garbage from a failed fgets() call on stdin.
 * This was particularly nasty if stdin hadn't been opened (e.g. by
 * using the shell's "<&-" construct) - this resulted in a read from
 * fd0, which was being used for the SNMP socket!
 *                              (Patch supplied by Tony Stoneley)
 *
 * Revision 1.1.1.1.2.8  1999/04/13 05:13:35  nevil
 * Use log_msg for ALL error messages
 *
 * Revision 1.1.1.1.2.7  1999/02/16 03:59:11  nevil
 * *** empty log message ***
 *
 * Revision 1.1.1.1.2.6  1999/02/16 03:42:18  nevil
 * *** empty log message ***
 *
 * Revision 1.1.1.1.2.5  1999/02/15 21:24:09  nevil
 * Distribution file for 4.3b9
 *
 * Revision 1.1.1.1.2.4  1999/02/03 21:56:20  nevil
 * Distribution file for 4.3b8
 *
 * Revision 1.1.1.1.2.3  1999/01/20 03:55:52  nevil
 * Implementation of TCP attributes, part 4
 *
 * Revision 1.1.1.1.2.1  1998/11/25 03:30:13  nevil
 * Fix endian problems in NetFlowMet
 *
 * Revision 1.1.1.1  1998/11/16 03:57:29  nevil
 * Import of NeTraMet 4.3b3
 *
 * Revision 1.1.3.1.2.2  1998/10/19 22:32:49  nevil
 * Meter improvements, mostly arising from developments for the
 * OCxMON meter.  These are documented in notes_oc.txt
 *
 * Revision 1.1.3.1.2.1  1998/10/18 20:51:27  nevil
 * Added Nicolai's patches, some 'tidying up' of the source
 *
 * Revision 1.1.3.1  1998/10/13 02:48:41  nevil
 * Import of Nicolai's 4.2.2
 *
 * Revision 1.6  1998/10/02 15:00:30  nguba
 * Added print_help to display command-line options
 *
 * Revision 1.5  1998/06/10 21:12:03  rtfm
 * Implement popto/poptoact actions for SRL
 *
 * Revision 1.3  1998/05/22 03:57:35  rtfm
 * Implement better hashing algorithm for flow and rule tables
 */

#if HAVE_CONFIG_H
#include <ntm_conf.h>
#endif

#define CORAL_TIME_OFFSET   0
#define CORAL_BUFFER_TRACE  1
#define LOG_BAD_TIMESTAMPS  1  /* If you set this,  run meter
                      inside gdb, and set breakpoint on quack */
#define UX_TESTING       0  /* Outer block (osp) trace */
#define COPY_STRUCTS     0  /* True to copy fddi 'ethernet header' info.
                              Solaris 2.4 doesn't need this */
/* #define DAG_DELAY_READ   0  /* Delay Dag reads by select_us */
/* My Dag 3.2 cards don't seem to do blocking reads.  Worse,
   they sometimes get bad timestamps (backward jumps), and 
   (worse still) they can stall, needing to be re-initialised.
   Delaying the reads, trying not to read too far ahead,
   seems to help a lot.                   Nevil, 3 Apr 03 */
/* My Dag 4.1 cards don't have this problem! */
/* define DAG_DELAY_READ moved to Makefile, 9 Apr 03 */

#define USR_TESTING      0  /* USR1 and USR2 signals will trigger trace */
#define KEEP_HISTORY     0  /* Maintain history info for threads */
#define IF_READ_TRACE    0  /* Trace to verify i/f reads and timestamps */
#define DAG_EXT_TESTING  0  /* For debugging varlen slen=nn */
#define DEBUG_TF_READ    0  /* For debugging trace-file input */
#define TRACE_BADT_RECS  0  /* To look for ts seq errors from DAG cards */

#define WATCH_RUN_LIGHT  DAG_HW_RESET  /* Watch system tod in o/b loop */

#define LOG_THREAD_PROCTIMES  0

#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#if HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif
#include <sys/utsname.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <stdarg.h>
#include <signal.h>

#include <sys/stat.h>  /* For reading libpcap trace files */
#include <fcntl.h>

#include <time.h>
#include <sys/time.h>
#include <sys/times.h>
#include <limits.h>

#ifdef SUNOS
#include <stropts.h>
#define void
#define const
#endif

#if MULTI
# include <pthread.h>
# include "threads/semaphore.h"
#endif

#define EXTSNMP
#include "ausnmp.h"
#include "asn1.h"
#include "snmp.h"
#include "snmpimpl.h"

#define MXINTERFACES  4  /* Max nbr of interfaces to meter */

#define PKTSNAP
#include "pktsnap.h"
#include "flowhash.h"
#include "met_vars.h"

#define APPLETALK

extern char version_descr[];  /* In met_vars.c */
extern char *communities[];  /* In snmp/snmpagnt.c */
extern unsigned long pc_noflowpkts;  /* In met_vars.c */
extern char *logname;  /* In met_vars.c */
#if LOG_DNS_PKTS || LOG_METER_STATS
extern char *ofname;  /* In flowhash.c */
#endif

#if NF_CISCO_DATA
# include "flowdata.h"
#elif LFAP_METER
# include "lfapmet.h"
# include <snmpapi.h>
# include "snmpclnt.h"
#else
# include <unistd.h>
# include "pcap-int.h"
# include "pcap.h"
# include "llc.h"
# if CR_DATA
#  include "libcoral.h"  /* CoralReef needs libpcap */
# endif
#endif

#if NF_OCX_BGP
# include "../bgp/integrat/readbgp.h"
# include "../bgp/integrat/subnet.h"
#endif

# if KEEP_HISTORY
#define HIST_SZ  16
struct hist_rec {
   char name[HIST_SZ];
   int hx;
   char h[HIST_SZ];  int hn[HIST_SZ];
   };
struct hist_rec dm_hist;

void init_hist(struct hist_rec *hr, char *n)
{
   memset(hr, 0, sizeof(struct hist_rec));  
   strncpy(hr->name, n, sizeof(hr->name));
   }

void update_hist(struct hist_rec *hr, char c, int n)
{
   hr->h[hr->hx] = c;  hr->hn[hr->hx] = n;
   if (++hr->hx == HIST_SZ) hr->hx = 0;
   }

void print_hist(struct hist_rec *hr)
{
   int j, k;
   printf("%s(", hr->name);
   for (j = 0, k = hr->hx; j != HIST_SZ-1; ++j, k = (k+1)%HIST_SZ)
      printf("%c:%d,", hr->h[k],hr->hn[k]);
   printf("%c:%d)\n", hr->h[hr->hx],hr->hn[hr->hx]);
   fflush(stdout);
   }
#else
#define init_hist(hr,n)
#define update_hist(hr,c,n)
#define print_hist(hr)
#endif

#if HAVE_LIBZ
# include <zlib.h>
#endif

#if DAG_DIRECT
# include <dagnew.h>

# if DAG_NEW_API
#  include <sys/mman.h>
#  include <dagapi.h>
# endif

/* Dag trace file record layouts ...
      Note that the 'legacy' formats use 64-byte fixed-length records */

struct dag_atm {  /* Dag record for ATM (first cell only, a la OC3MON) */
   Bit32 crc;           /* Always zero */
   Bit32 atm_hdr;       /* VPI:VCI, etc */
   struct snap_hdr sh;  /* LLC snap header (8 bytes) */
   Bit8 pload[40];      /* First 40 bytes of IP packet */
   };

struct dag_ether {  /* Dag record for Ethernet */
   Bit16 wlen;          /* Wire length (bytes) */
   struct ether_hdr eh; /* Ethernet MAC header */
   Bit8 pload[40];
   };

struct dag_pos {  /* Dag record for PoS */
   Bit32 rlen;          /* Snap length, must be 64 for now */
   Bit16 llctr;         /* Loss counter (due toPCI bus overload) */
   Bit16 wlen;          /* Bytes on the wire, seems to include FCS */
   Bit8 chdlc;          /* Cisco HDLC header (this + next 3 bytes) */
   Bit8 unused;         /* Padding */
   Bit16 etype;         /* EtherType */
   Bit8 pload[44];      /* 4 more bytes than ATM and Ether */
   };

struct dag_ext_pos {  /* Extensible Type 1, PoS HDLC */
   Bit8 chdlc;          /* Cisco HDLC header (this + next 3 bytes) */
   Bit8 unused;         /* Padding */
   Bit16 etype;         /* EtherType */
   Bit8 pload[44];      /* rlen-20, rlen default is 64 */
   };

struct dag_ext_ether {  /* Extensible Type 2, Ethernet */
   Bit8 offset;         /* Bytes to skip (not captured) */
   Bit8 pad;            /* Reserved */
   struct ether_hdr eh; /* Ethernet MAC header */
   Bit8 pload[32];      /* rlen-18 */
   };

struct dag_ext_atm {  /* Dag record for ATM (first cell only, a la OC3MON) */
   Bit32 atm_hdr;       /* VPI:VCI, etc */
   struct snap_hdr sh;  /* LLC snap header (8 bytes) */
   Bit8 pload[40];      /* Data bytes for cell */
   };

struct dag_ext {      /* 'Extensible' Dag record */
   Bit8 type;           /* Dag type (TYPE_ defines, in dag.h) */
   Bit8 flags;          /* Dag flags (DF_ defines, below) */
   Bit16 rlen;          /* Dag data length */
   Bit16 lctr;          /* Loss counter, sticks at 0xffff */
   Bit16 wlen;          /* Bytes on the wire */
   union {
      struct dag_ext_pos pos;
      struct dag_ext_ether eth;
      struct dag_ext_atm atm;
      } e;
   };

#define DF_INTERFACE  0x03  /* Capture interface 0-3 */
#define DF_VBL_LEN    0x04  /* Variable length records */
#define DF_TRUNCATED  0x08  /* Record truncated (insufficient buffer space) */
#define DF_RX_ERROR   0x10  /* Rx error (link layer) */
#define DF_DS_ERROR   0x20  /* Internal error */
#define DF_RSRV       0xC0  /* Reserved */

#define TT_ATM    0  /* Dag trace file record types */
#define TT_ETHER  1
#define TT_POS    2
#define TT_EXT    3

#define TYPE_LEGACY    0  /* Values for dag_ext type field */
#define TYPE_HDLC_POS  1
#define TYPE_ETH       2
#define TYPE_ATM       3

#define DAG_DEFAULT_SLEN   48  /* These match the Legacy records */
#define DAG_DEFAULT_VARLEN  0

struct dag_rec {
   long long ts;        /* Dag timestamp (64-bit) */
   union {
      struct dag_atm atm;
      struct dag_ether eth;
      struct dag_pos pos;
      struct dag_ext ext;
      } d;
   };

# if MULTI
#  define N_DAG_BUFS  8*16384/DAG_BUF_SZ  /* * MB per interface */
# else
#  define N_DAG_BUFS  1  /* Only one for single-thread meter */
# endif

#endif  /* DAG_DIRECT */

#define SZ_IFNAME  128
struct interface_info {
   u_char nbr;  /* Interface number (for Surce/DestInterface attributes) */
   u_char adjtype;  /* Adjacent type for interface */
   char name[SZ_IFNAME+1];  /* Interface name, e.g. nf0 */
   u_int SampleRate,  /* 1 = count every packet on this interface */
      sample_count;
   int fd, last_errno;
   u_int ipackets;  /* Total packets */
   u_int idrops;  /* Dropped packets */
   u_int noflowpackets;

# if HAVE_LIBZ
   gzFile gfp;  /* For reading trace files */
# endif

#if NF_CISCO_DATA
   struct sockaddr_in from;
   char *nf_buf;

#elif LFAP_METER
   FASInfo fasinfo;

#elif DAG_DIRECT || CR_DATA
#  define MN_SELECT_US  4000  /* 4 ms */
  //#  define MN_SELECT_US  2000  /* 2 ms */
#  define MX_SELECT_US   (8*MN_SELECT_US)
#  define TARGET_CPB  700
  //#  define TARGET_CPB  300
         /* Try to vary select_us to keep cpb above this */
   /* With Dag 3.2 cards on netramet.caida we get lots of very small reads.
      We wait for select_us microseconds before reading, having found that
      fewer, slightly bigger reads seem to be more reliable than lots of
      small ones.                                Nevil, Mon 16 Sep 02 */

   int nblocks,last_nblocks;
   int nrecords;  /* For osp() 5-min log records */
   u_int badtspkts;  /* Packets with bad timestamps */
   u_int no_data_warned;
   int last_s;  /* State from last read */
#     define S_NORMAL  0
#     define S_EMPTY   1
#     define S_FULL    2
   u_int full,empty, mx_full,mx_empty;
   int consec_badts, restarts;

# if DAG_DIRECT
   int t_fd;  /* For reading trace files */
#   define DF_BLK_SZ  0x10000
// #   define DF_BLK_SZ  1024
   Bit8 *fbuf;
   int
      fbr,  /* Nbr of fbuf bytes read in last block */
      fbx;  /* Index in fbuf of first byte of current record */

   int dag_type, dag_slen;
   int dag_ports;
#  if DAG_NEW_API
   int dag_varlen;
   void *dbuf;  /* Dag driver buffer */
   unsigned bottom;  /* Offset of next byte to read */
   unsigned n_stuck_lctrs;  /* Nbr of time lctr reached 0xFFFF */
   struct dag_rec *dbp;
   int r_pkts;
#  else
   Bit8 *in_buf[N_DAG_BUFS];  /* Array of buf pointers */
   int in_bytes[N_DAG_BUFS];
   int inx, outx;
#  endif
   int running;
   int r_bytes;  /* Bytes left in this block */
   int n_pkts;  /* Packets found so far in this block */
   struct dag_rec *drp;  /* Current record in this block */
   long long last_read_ts;  /* First ts of last block */
   long long card_ts;  /* Last ts of last block */
#  if MULTI
   Semaphore db_ready, db_empty;  /* Dag buffer queue */
   pthread_t dag_thread;
#  endif
# elif CR_DATA
   coral_source_t *crl_src;
   coral_iface_t *iface;
   struct timeval card_ts;  /* For next cell */
   coral_atm_cell_t *cellp;
#  if CORAL_TIME_OFFSET
      struct timeval ts_offset;  /* Accumulated time error from card */
#  endif
# endif

#elif DAG_DATA  /* ADSL */

#else  /* libpcap */
# define LIBPCAP  1

   pcap_t *pd;
   pcap_handler callback;
   struct pkt *p_head, *p_tail;  /* Chain of pkts, could be empty */
   int p_qlen;  /* Nbr of pkts in chain */
   int stall_warned;
   Bit32 iblocks;  /* Nbr of blocks read */
   int n_pkts_read;  /* Pkts read in last block */
# if MULTI
   Semaphore ib_ready, ib_empty;  /* Interface packet chain */
   pthread_t input_thread;
# endif
#endif
   };

struct interface_info *pci[MXINTERFACES];

int live_source = 1;  /* Set to zero to use trace files */

static int crl_n_max = 0;  /* Set by -N option */
static int crl_n_count;    /* Counting to crl_n_max */
static int trace_count;    /* Counter for 1s intervals within trace_interval */

static Bit32
    npackets_org = 0L, lostpackets_org = 0L, 
    pkts = 0L, drops = 0L;

#if DAG_DIRECT
ts_type meter_start_time = 0;  /* Dag (64-bit) timestamp */
#else
ts_type meter_start_time = {0, 0};
#endif
double meter_start_us;  /* Start time in Unix us */
int start_us_needed = 1;

/* Make SIGINT or SIGTERM shut the meter down gracefully */

int request_stop = 0;
void sigint_handler(int x)  /* INT (keyboard) and TERM (kill) */
{                /* To make ^c send INT, use   stty intr '^c' */
   request_stop = 1;
   }

int got_USR1 = 0;
void sigusr1_handler(int x)  /* kill -USR1 */
{
   got_USR1 = !got_USR1;
   }

int got_USR2 = 0;
void sigusr2_handler(int x)  /* kill -USR2 */
{
   got_USR2 = !got_USR2;
   }

#if MULTI
#if 0
#define PME_BUF_RECS     59
#define PME_BUF_RECS    113
#define PME_BUF_RECS    493
#define PME_BUF_RECS   1019
#define PME_BUF_RECS   2029
#define PME_BUF_RECS   4091
#define PME_BUF_RECS   8187
#define PME_BUF_RECS  16369
#endif

#if MULTI_BUF_SZ == 3
#define PME_BUF_RECS    113
#elif MULTI_BUF_SZ == 2
#define PME_BUF_RECS     59
#elif MULTI_BUF_SZ == 1
#define PME_BUF_RECS     23
#else  /* For testing on low-bit-rate links */
#define PME_BUF_RECS      2
#warning ---> PME_BUF_RECS  2 <----
#endif

#if LOG_THREAD_PROCTIMES
FILE *threads_log;
#define MAX_THREADS  12
#define THR_NAME_SZ  20
int assign_thr_log_nbr(void);
char thread_name[MAX_THREADS][THR_NAME_SZ];
Bit32 thread_proctime[MAX_THREADS];
Bit32 thread_proctime_org[MAX_THREADS];

int t_log_n = 0;
int assign_thr_log_nbr(void)
{ return t_log_n++; }
#endif

# if THREAD_GPROF
/* Following wrapper code to make gprof work properly for threads
   is from   http://sam.zoy.org/doc/programming/gprof.html  */

/* 
 * pthread_create wrapper for gprof compatibility
 *
 * needed headers: <pthread.h>
 *                 <sys/time.h>
 */

typedef struct wrapper_s {
    void * (*start_routine)(void *);
    void * arg;

    pthread_mutex_t lock;
    pthread_cond_t  wait;

    struct itimerval itimer;
    } wrapper_t;

static void * wrapper_routine(void *);

/* Same prototype as pthread_create; use some #define magic to
 * transparently replace it in other files */
int gprof_pthread_create(pthread_t * thread, pthread_attr_t * attr,
			 void * (*start_routine)(void *), void * arg)
{
   wrapper_t wrapper_data;
   int i_return;

   /* Initialize the wrapper structure */
   wrapper_data.start_routine = start_routine;
   wrapper_data.arg = arg;
   getitimer(ITIMER_PROF, &wrapper_data.itimer);
   pthread_cond_init(&wrapper_data.wait, NULL);
   pthread_mutex_init(&wrapper_data.lock, NULL);
   pthread_mutex_lock(&wrapper_data.lock);

   /* The real pthread_create call */
   i_return = pthread_create(thread, attr, &wrapper_routine,
			    &wrapper_data);

   /* If the thread was successfully spawned, wait for the data
    * to be released */
   if(i_return == 0) {
      pthread_cond_wait(&wrapper_data.wait, &wrapper_data.lock);
      }

   pthread_mutex_unlock(&wrapper_data.lock);
   pthread_mutex_destroy(&wrapper_data.lock);
   pthread_cond_destroy(&wrapper_data.wait);

   return i_return;
   }

/* The wrapper function in charge for setting the itimer value */
static void * wrapper_routine(void * data)
{
   /* Put user data in thread-local variables */
   void * (*start_routine)(void *) = ((wrapper_t*)data)->start_routine;
   void * arg = ((wrapper_t*)data)->arg;

   /* Set the profile timer value */
   setitimer(ITIMER_PROF, &((wrapper_t*)data)->itimer, NULL);

   /* Tell the calling thread that we don't need its data anymore */
   pthread_mutex_lock(&((wrapper_t*)data)->lock);
   pthread_cond_signal(&((wrapper_t*)data)->wait);
   pthread_mutex_unlock(&((wrapper_t*)data)->lock);

   /* Call the real function */
   return start_routine(arg);
   }
# else
# define gprof_pthread_create(thread, ta, f, arg)  \
      pthread_create(thread, ta, f, arg)
# endif
#endif


#if LINUX
# include <unistd.h>
# include <sys/sysinfo.h>
#elif SOLARIS
#include <unistd.h>
#elif FREEBSD || NETBSD
# include <sys/types.h>
# include <sys/sysctl.h>
#elif OPENBSD
# include <sys/lock.h>
# include <sys/sysctl.h>
#elif ALPHA
# include <sys/sysinfo.h>
#endif

void get_sys_info(int hyperthread_processors)
{
#if LINUX
   phys_mem = sysconf(_SC_PAGE_SIZE) * sysconf(_SC_PHYS_PAGES);
   n_procs = get_nprocs_conf();
#elif SOLARIS
   phys_mem = sysconf(_SC_PAGE_SIZE) * sysconf(_SC_PHYS_PAGES);
   n_procs = sysconf(_SC_NPROCESSORS_ONLN);
#elif FREEBSD || NETBSD || OPENBSD
  int mib[2];
  size_t len = sizeof(unsigned int);

  mib[0] = CTL_HW;
  mib[1] = HW_NCPU;
  sysctl(mib, 2, &n_procs, &len, NULL, 0);
  mib[1] = HW_PHYSMEM;
  sysctl(mib, 2, &phys_mem, &len, NULL, 0);
# if OPENBSD 
#  undef max_offset  /* lfapmet.c uses this symbol !!? */
# endif
#elif ALPHA
   long pm;
   getsysinfo(GSI_PHYSMEM, (char *)&pm, sizeof(pm), NULL,NULL,NULL);
   phys_mem = (int)pm * 1024; 
   getsysinfo(GSI_CPUS_IN_BOX, (char *)&n_procs, sizeof(n_procs), NULL,NULL,NULL);
#else
   phys_mem = 1024*1024;  /* 1 MB.  Avoids divide by zero later! */
   n_procs = 1;
#endif
   if (hyperthread_processors) n_procs /= 2;
      /* Linux counts Intel Xeon chips as two processors - 
         although they run two threads each, they only have
         one actual processor! */
   } 


void stop_meter(int code)
{
   log_msg(LOG_INFO, 0, "Shutting down");
#if LOG_DNS_PKTS
   close_data();
#endif
#if CR_DATA
   coral_stop_all();  /* Leave Dag cards in a graceful state */
   coral_close_all();
#endif
#if DAG_NEW_API
   if (live_source)
      dag_close_all();
#endif
#if MULTI
   destroy_mutexes();
#endif
   exit(code);
   }


void init_tracefile_read(char *ifname, char *ifkind)
{
   char buf[150], *info_string;
   int len;

   live_source = 0;  /* User wants to read trace file(s) */
   trace_count = trace_interval;
   crl_n_count = 0;

   sprintf(buf, "%d  -i%s (%s trace file)",
      trace_interval,  /* NeMaC uses this for its collection interval */
      ifname, ifkind);
   len = strlen(buf);
   info_string = (char *)malloc(len+1);
   strcpy(info_string, buf);
   crl_info = info_string;
      /* NeMaC writes this to a #InputInfo record */
#if DEBUG_TF_READ
   printf("init_tracefile_read(): crl_info='%s'\n", crl_info);
#endif
   }

#if DAG_DIRECT
void fmt_ts(char *t_buf, ts_type t)
{
   long long mt = t - meter_start_time;
   char *neg = "";
   if (mt < 0) {
      mt = -mt;  neg = "-";
      }
   sprintf(t_buf, "%s%lu.%06lu", neg, DAGT_S(mt),DAGT_US(mt));
   }
#elif LIBPCAP
void fmt_ts(char *t_buf, double t)
{
   double mt = t - meter_start_us;
   sprintf(t_buf, "%.6f", mt/1000000.0);
   }
#else
void fmt_ts(char *t_buf, ts_type t)
{
   tv_sub(t, meter_start_time);
   sprintf(t_buf, "%lu.%06lu", t.tv_sec, t.tv_usec);
   }
#endif

#if MULTI  /* Run match threads */
# if PKT_DEBUG > 1
int n_r_p_pr = 0;
# endif

pthread_t osp_thread;

# if LOG_THREAD_PROCTIMES
int osp_tn = 0;  /* Set by run_osp() */
# endif
Bit32 last_osp_proct = 0;

void *run_osp(void *arg)
{
/*     int n = 0;  /*^*/
# if LOG_THREAD_PROCTIMES
   osp_tn = assign_thr_log_nbr();
   sprintf(thread_name[osp_tn], "o_s_p");
   thread_proctime_org[osp_tn] = thread_proctime[osp_tn] = 0;
# endif   

   for (;;) {
      ntm_semaphore_down("osp", &osp_semaphore);  /* Wait for trigger */
/*  printf("osp<%d> ", ++n);  fflush(stdout);  /*^*/
      one_second_process();
      }
   return NULL;  /* Keep compiler happy */
   }

# if PKT_DEBUG
void check_pkt_chain(struct pkt_chain *pc, int which)
{
   struct pkt *pme_pp, *last_pp;
   int j;

   for (j = 0, pme_pp = pc->pm_head; pme_pp != NULL; ) {
      ++j;
      if (pme_pp->pkt_state != 1) {
         printf("chk_pkt_chain(1): not got, j=%, pme_pp=%x\n", j, pme_pp);
         quack(701);
         }
      last_pp = pme_pp;
      pme_pp = pme_pp->next_pp;
      }
    if (j != PME_BUF_RECS) {
      printf("chk_pkt_chain(2): wrong nbr of pkts, got %d, should be %d\n",
         j, PME_BUF_RECS);
      quack(702);
      }
    if (last_pp != pc->pm_tail) {
      printf("chk_pkt_chain(3): last pkt not at pc->pm_tail\n");
      quack(703);
      }
   }
# endif

void *run_pme(void *arg)
{
   struct pme_data *pd = (struct pme_data *)arg;
   struct pkt_chain *pc;
   struct pkt *pme_pp, *npp;
   Bit32 pme_proct,
      last_pme_proct = 0;
   struct tms tbuf;

# if LOG_THREAD_PROCTIMES
   int this_tn = assign_thr_log_nbr();
   sprintf(thread_name[this_tn], "pme %d", pd->hash_group);
   thread_proctime_org[this_tn] = thread_proctime[this_tn] = 0;
# endif   
   for (;;) {
      ntm_semaphore_down("pme", &pd->buf_full);
         /* Block until we have a full pme input buff */

      pc = &pd->chain[pd->outx];
# if PKT_DEBUG > 1
      check_pkt_chain(pc, 1);
# endif
      for (pme_pp = pc->pm_head; pme_pp != NULL; ) {
# if PKT_DEBUG > 1
         printf("r_p(%x) ", pme_pp);
         if (++n_r_p_pr == 8) { printf("\n");  n_r_p_pr = 0; }
         fflush(stdout);
# endif
# if PKT_DEBUG
      if (pme_pp->pkt_state != 1) {
         printf("run_pme(1): not got, pme_pp=%x\n", pme_pp);
         quack(707);
         }
# endif
         npp = pme_pp->next_pp;
/*    printf("p"); fflush(stdout);  /*p*/
// // free_pkt(pme_pp);  // //
//?   printf("M");  fflush(stdout);  //?
         process_pkt(pme_pp);

         pme_pp = npp;
         }

      if (++pd->outx == N_PME_BUFS) pd->outx = 0;
      ntm_semaphore_up("pme", &pd->buf_empty);
         /* This pme input buffer is now empty */

      times(&tbuf);
      pme_proct = tbuf.tms_utime+tbuf.tms_stime;
      total_thread_proct += (pme_proct - last_pme_proct);
# if LOG_THREAD_PROCTIMES
      thread_proctime[this_tn] += (pme_proct - last_pme_proct);
# endif   
      last_pme_proct = pme_proct;
      }
   return NULL;  /* Keep compiler happy */
   }

void t_pkt_monitor(struct pkt *p_p)
{
# if N_PME_THREADS == 1
   struct pme_data *pd = &pme_data_buf[0];
# else
   struct pme_data *pd = &pme_data_buf[p_p->hash_group];
# endif
   struct pkt_chain *pc = &pd->chain[pd->inx];
/*-   struct timeval tv1, tv2; */

# if PKT_DEBUG
   if (p_p->pkt_state != 1) {
      printf("t_pkt_monitor(): not got, p_p=%x\n", p_p);  fflush(stdout);
      quack(707);
      }
# endif
   /*  printf("%d", pd->hash_group);  /*?*/
   /*  free_pkt(p_p);  return;  /*?*/
   /*   if (pd->hash_group != 0) {
       free_pkt(p_p);  return; }  /*?*/

//?   printf(".");  fflush(stdout);  //?
   if (pd->pbx == 0)
      pc->pm_head = pc->pm_tail = p_p;
   else {
      pc->pm_tail->next_pp = p_p;  pc->pm_tail = p_p;
      }
   if (++pd->pbx != PME_BUF_RECS) return;
//?   printf("+");  fflush(stdout);  //?

# if PKT_DEBUG > 1
   printf("\nt_p_m(): pbx=%d, head=%x, tail=%x, n_free_pkts=%d\n",
      pd->pbx,pd->pkt_buf_head,pd->pkt_buf_tail,n_free_pkts);  fflush(stdout);
# endif
   pc->pm_tail->next_pp = NULL;  /* Set the queue end marker */
   if (++pd->inx == N_PME_BUFS) pd->inx = 0;
   pd->pbx = 0;
# if PKT_DEBUG > 1
   check_pkt_chain(pc, 2);
# endif
   ntm_semaphore_up("tpm", &pd->buf_full);  /* OK, pkt_chain ready for PME */

/*-   gettimeofday(&tv1, (struct timezone *)0); */

   ntm_semaphore_down("tpm", &pd->buf_empty);  /* Block until pkt_buf free */

/*-   gettimeofday(&tv2, (struct timezone *)0);
   tv_sub(tv2, tv1);
   if (tv2.tv_usec > 500) printf("*"); */
   }


# if !DAG_DIRECT  /* Assume Unix, i.e. libpcap */

#  define PKT_TEST  0
#  define MX_NO_BLKS  100  /* Max 0-byte read_blks for an interface */

void input_merge()
{
   double ts, mints;
   int j, minj, starting;
   struct pkt *pbp;
   static Bit32 save_lts = 0;
   static int zero_pkt_intervals = 0;
   int t_delta;
   struct interface_info *pi;
   int mx_pkts_read;  

#if MULTI
   Bit32 input_merge_proct,
      last_input_merge_proct = 0;
   struct tms tbuf;
#endif
#if LOG_THREAD_PROCTIMES
   int this_tn = assign_thr_log_nbr();
   sprintf(thread_name[this_tn], "input_merge");
   thread_proctime_org[this_tn] = thread_proctime[this_tn] = 0;
#endif   

   for (;;) {  /* Run until one i/f queue is empty */
      minj = -1;
      for (j = 0; j < n_interfaces; ++j) {
         if ((pbp = pci[j]->p_head) == NULL) {  /* Empty queue */
	   if (mx_pkts_read > mxpkts*2/3) {
               if (!pci[j]->stall_warned) {
                  log_msg(LOG_WARNING, 0, "i/f %d, no data <<<", pci[j]->nbr);
                  pci[j]->stall_warned = 1;
                  }
               }
            continue;
            }
         if (minj < 0) {
            mints = pbp->arrival_time;  minj = j;
            }
         else {
            ts = pbp->arrival_time;  /* Find min timestamp */
            if (ts < mints) {
               mints = ts;  minj = j;
               }
            }
         }

      if (minj < 0) {  /* No packets! */
         /* CAUTION: handle_pkt() ignores non-metered protocol packets! */
         if (n_running_rts != 0) { /* Rulesets are running */
            if (++zero_pkt_intervals == 10) {
               log_msg(LOG_ERR, 0, "No data on any interface!!!"); /**/
               zero_pkt_intervals = 0;
               }
#if MULTI_BUF_SZ == 0  /* Testing on low-rate interfaces/links */
	    sleep(1);  /* Wait for some packets */
#endif
            }
//  r -ieth1 -m1161 -t300000 -f60000 -wtest
         pi = pci[0];  /* Look for pkts on interface 1 */
         }
      else {  /* We have at least one pkt */
         zero_pkt_intervals = 0;
         pi = pci[minj];
         pbp = pi->p_head;
         if (pbp == pi->p_tail) {
            pi->p_head = pi->p_tail = NULL;
            }
         else pi->p_head = pbp->next_pp;
            /* CAUTION: pcap _callback routines don't set pbp->next_pp! */
         --pi->p_qlen;  /* Pkts remaining in buffer */

//IP++         ++pi->ipackets;  /* For global statistics */
         /*   printf("i_m() i/f %d, %u, %u.%06u\n",
            pbp->Low.Interface, pbp->p_len, mints.tv_sec,mints.tv_usec); /**/

#if 0
 {
   struct stream *sp;
   sp = pbp->sp;
   printf("input_merge(%d): sp=%d: ", minj, stream_nbr(sp));
   daddr(pbp->Low.PeerAddress.qbyte);  printf("-");
   daddr(pbp->High.PeerAddress.qbyte);  printf(" ");
   dport(pbp->Low.TransAddress);  printf("-");
   dport(pbp->High.TransAddress);
   printf(" at=%d, pt=%d => ", pbp->PeerAddrType,  pbp->TransAddrType);
   daddr(sp->sfn.SrcPeerAddr);  printf("-");
   daddr(sp->sfn.DestPeerAddr);  printf(" ");
   dport(sp->sfn.SrcTransAddr);  printf("-");
   dport(sp->sfn.DestTransAddr);
   printf(" at=%d, pt=%d, dirn=%d.  pkts=%u\n",
      sp->sfn.PeerType,  sp->sfn.TransType, pbp->opp_dir, sp->ToPDUs+sp->FromPDUs);
   fflush(stdout);
   }
#endif

         t_pkt_monitor(pbp);
         }

      if (pi->p_qlen == 0) {  /* No pkts left in queue */
         ntm_semaphore_up("ndr", &pi->ib_empty);
            /* Wait while run_if_read gets the next block */
         ntm_semaphore_down("gnb", &pi->ib_ready);

         mx_pkts_read = pci[0]->n_pkts_read;
         for (j = 0; j < n_interfaces; ++j) {  /* May only be 1 interface! */ 
            if (pci[j]->n_pkts_read > mx_pkts_read)
               mx_pkts_read = pci[j]->n_pkts_read;
            }
//IR printf("i_m(): read block for i/f %d, p_qlen=%d, mx_pkts_read=%d\n",
//    minj, pi->p_qlen, mx_pkts_read);  fflush(stdout);  //IR

# if MULTI
         if (pi->iblocks % 20 == 0) {
            times(&tbuf);
            input_merge_proct = tbuf.tms_utime+tbuf.tms_stime;
            total_thread_proct += (input_merge_proct - last_input_merge_proct);
#  if LOG_THREAD_PROCTIMES
            thread_proctime[this_tn] +=
               (input_merge_proct - last_input_merge_proct);
#  endif   
            last_input_merge_proct = input_merge_proct;
            }
# endif
         }

      if (!live_source) {  /* Reading a trace file */
         if (pi->ipackets % 10000 == 0) {  /* Indicate progress */
            printf(minj == 0 ? "." : ":");  fflush(stdout);
            }

#if DEBUG_TF_READ > 1
   printf("*** mr(1) *** "
      "last_t_sec=%d, save_lts=%d, pi=%x, pi->pd=%x, ipackets=%d\n",
      last_t_sec, save_lts, pi, pi->pd, pi->ipackets);  fflush(stdout);  //T
#endif

   //TS  printf("mr(0): last_t_sec=%d, save_lts=%d, meter_start_us=%f, ipackets=%d\n",
   //TS     last_t_sec, save_lts, meter_start_us/1000000.0, pi->ipackets);  //TS

         if (pi == NULL || pi->pd == NULL) {  /* EOF on trace file */
            ntm_semaphore_up("dm", &merge_sync_empty);
               /* Block until non_live_source decides what to do */
            ntm_semaphore_down("dm", &merge_sync_full);
            }
         else {
            if (last_t_sec > save_lts) {
               starting = save_lts == 0;
               if (save_lts != 0) {
                  t_delta = last_t_sec - save_lts;
                  /* if (t_delta != 1) printf("%d", t_delta); */
                  }
               save_lts = last_t_sec;
#if DEBUG_TF_READ
   printf("*** mr(2) *** trace_state=%d, trace_count=%d, "
         "t_delta=%d, full=%d, empty=%d\n"
	  "      save_lts=%d, ipackets=%d\n",
      trace_state, trace_count, t_delta,
         t_semaphore_value(&merge_sync_full),
         t_semaphore_value(&merge_sync_empty), save_lts, pi->ipackets);
   fflush(stdout);
#endif
               if (starting)  /* Just getting started */
                  ntm_semaphore_down("dm", &merge_sync_full);
               else if ((trace_count -= t_delta) <= 0) {
                  ntm_semaphore_up("dm", &merge_sync_empty);
                     /* Block until non_live_source decides what to do */
                  ntm_semaphore_down("dm", &merge_sync_full);
                  }
	       }
            }
         }
      }
   }

int interface_read(struct interface_info *pi);

void *run_if_read(void *arg)
{
   struct interface_info *pi = (struct interface_info *)arg;
   Bit32 ifr_proct,
      last_ifr_proct = 0;
   struct tms tbuf;

#  if LOG_THREAD_PROCTIMES
   int this_tn = assign_thr_log_nbr();
   sprintf(thread_name[this_tn], "run_if_read");
   thread_proctime_org[this_tn] = thread_proctime[this_tn] = 0;
#  endif   

   for (;;) {
      ntm_semaphore_down("rdr", &pi->ib_empty);
         /* Block until input_merge consumes our pkts */

      ++pi->iblocks;
      pi->stall_warned = 0;
      interface_read(pi);  /* callback() will read the pkts */

//IR  printf("run_if_read(): interface_read returned p_qlen=%d\n",
//     pi->p_qlen);  fflush(stdout);  //IR
      ntm_semaphore_up("rdr", &pi->ib_ready);
         /* Tell input_merge we *may* have some more packets */
 
      times(&tbuf);
      ifr_proct = tbuf.tms_utime+tbuf.tms_stime;
      total_thread_proct += (ifr_proct - last_ifr_proct);
#  if LOG_THREAD_PROCTIMES
      thread_proctime[this_tn] += (ifr_proct - last_ifr_proct);
#  endif   
      last_ifr_proct = ifr_proct;

      }
   return NULL;  /* Keep compiler happy */
   }

#  endif  /* !DAG_DIRECT */
#else  /* !MULTI (i.e. single-threaded) */

void dump_bp(struct pkt *bp);

# define t_pkt_monitor(pbp)  process_pkt(pbp);

#endif


#if NF_CISCO_DATA

void interface_read(struct interface_info *pi)
{
int kk;  //15
   int flen, j;
   char msg[60];
   int nf_version;
   IPStat1Msg *nf1;  IPFlow1Stat *fr1;
   IPStat5Msg *nf5;  IPFlow5Stat *fr5;
   struct pkt *p_p;
   Bit16 as;
   Bit32 uptime_delta;
   /* SysUptime (from packet header) is normally a few seconds behind
      the NetFlowMet meter, which means that flow FirstTime and LastTime
      are negative numbers.  To get this to work properly, we force an
      integer divide by 10 when converting to centiseconds (below).
      InactivityTimeout is usually measured in minutes (default 600s),
      and garbage_collect() uses unsigned compares against LastTime, so
      NetFlowMet will time flows out properly. */

   flen = sizeof(pi->from);
   //   if (recvfrom(pi->fd, pi->nf_buf, MAX_FLOW_PAK_SIZE, 0, 
   if ((kk = recvfrom(pi->fd, pi->nf_buf, MAX_FLOW_PAK_SIZE, 0,  //15
         (struct sockaddr *)&pi->from, (socklen_t *)&flen)) < 0) {
      log_msg(LOG_ERR, 0, "nf_read(%s): recvfrom failed", pi->name);
      return;
      }

   nf_version = pi->nf_buf[0] << 8 | pi->nf_buf[1];
   if (nf_version == FLOW_VERSION_1) {
      nf1 = (IPStat1Msg*)pi->nf_buf;

// printf(".");  fflush(stdout);
//      printf("%d bytes, %d nf records\n", kk, ntohs(nf1->header.count));  //15
// printf("kk=%d: ", kk);
// for (j = 0; j != 32; ++j) printf(" %02x", (Bit8)pi->nf_buf[j]);
// printf("\n"); fflush(stdout);

      uptime_delta = ntohl(nf1->header.SysUptime)/10 - uptime_cs();
      for (fr1 = nf1->records, j = 0; 
            j != ntohs(nf1->header.count); ++fr1, ++j) {
         pi->ipackets += ntohl(fr1->dPkts);
         if ((p_p = get_pkt()) == NULL) {  /* No free pkts, drop the packet */
            ++pi->idrops;
            continue;
            }
         p_p->PeerAddrType = AT_IP4;  /* Dummy up an IP packet */
         memcpy(&p_p->Low.PeerAddress.byte,&fr1->srcaddr,IP4_ADDR_LEN);
         memcpy(&p_p->High.PeerAddress.byte,&fr1->dstaddr,IP4_ADDR_LEN);
         p_p->TransAddrType = fr1->prot;
         p_p->Low.TransAddress = fr1->srcport;  /* Network byte order */
         p_p->High.TransAddress = fr1->dstport;
         p_p->Low.Interface = fr1->input;
         p_p->High.Interface = fr1->output;
         p_p->DSCodePoint = fr1->tos >> 2;
         p_p->ECNCodeBits = fr1->tos && 0x03;

         p_p->dPkts = ntohl(fr1->dPkts);
         p_p->dOctets = ntohl(fr1->dOctets);
         p_p->dFirst = ntohl(fr1->First)/10 - uptime_delta;  /* cs */
         p_p->dLast = ntohl(fr1->Last)/10 - uptime_delta;
         p_p->arrival_time = p_p->dLast*10000.0;  /* us */

         p_p->Low.AdjType = 0;  /* NetFlow attributes */
         p_p->Low.AdjAddr_ms4 = 0;  p_p->Low.AdjAddr_ls2 = 0;
#if 0    /* RTFM meter can't match S->D and D->S without having both */
         p_p->High.AdjType = AT_IP4;   /* addresses for EVERY packet */
         p_p->High.AdjAddr_ms4 = fr1->nexthop;  p_p->High.AdjAddr_ls2 = 0;
#else
         p_p->High.AdjType = 0;
         p_p->High.AdjAddr_ms4 = 0;  p_p->High.AdjAddr_ls2 = 0;
#endif
         p_p->Low.nf_ASN = p_p->High.nf_ASN = 0;
         p_p->Low.nf_mask = p_p->High.nf_mask = 0;

         p_p->if_nbr = p_p->ntm_interface = pi->nbr;  /* 28 Mar 04 */
               /* Remember interface from -i option */
         make_stream_for_pkt(p_p);
         process_pkt(p_p);
         }
      }
   else if (nf_version == FLOW_VERSION_5) {
      nf5 = (IPStat5Msg*)pi->nf_buf;
      uptime_delta = ntohl(nf5->header.SysUptime)/10 - uptime_cs();

      for (fr5 = nf5->records, j = 0; 
            j != ntohs(nf5->header.count); ++fr5, ++j) {
         pi->ipackets += ntohl(fr5->dPkts);
         if ((p_p = get_pkt()) == NULL) {  /* No free pkts, drop the packet */
            ++pi->idrops;
            continue;
            }
         p_p->PeerAddrType = AT_IP4;  /* Dummy up an IP packet */
         memcpy(&p_p->Low.PeerAddress.byte,&fr5->srcaddr,IP4_ADDR_LEN);
         memcpy(&p_p->High.PeerAddress.byte,&fr5->dstaddr,IP4_ADDR_LEN);
         p_p->TransAddrType = fr5->prot;
         p_p->Low.TransAddress = fr5->srcport;  /* Network byte order */
         p_p->High.TransAddress = fr5->dstport;
         p_p->Low.Interface = fr5->input;
         p_p->High.Interface = fr5->output;
         p_p->DSCodePoint = fr5->tos >> 2;
         p_p->ECNCodeBits = fr5->tos && 0x03;

         p_p->dPkts = ntohl(fr5->dPkts);
         p_p->dOctets = ntohl(fr5->dOctets);
         p_p->dFirst = ntohl(fr5->First)/10 - uptime_delta;  /* cs */
         p_p->dLast = ntohl(fr5->Last)/10 - uptime_delta;
            /* Was ntohl(fr5->First/10) !!!
               Bug reported by Oleg O.Orlov <OOO@vmts.ru>, 3 Oct 01 */
         p_p->arrival_time = p_p->dLast*10000.0;  /* us */

         p_p->Low.AdjType = 0;  /* NetFlow attributes */
         p_p->Low.AdjAddr_ms4 = 0;  p_p->Low.AdjAddr_ls2 = 0;
#if 0    /* RTFM meter can't match S->D and D->S without having both */
         p_p->High.AdjType = AT_IP4;   /* addresses for EVERY packet */
         p_p->High.AdjAddr_ms4 = fr5->nexthop;  p_p->High.AdjAddr_ls2 = 0;
#else
         p_p->High.AdjType = 0;
         p_p->High.AdjAddr_ms4 = 0;  p_p->High.AdjAddr_ls2 = 0;
#endif
#if 0  /* This works on PC, but crashes on SPARC - not short-aligned */
         *(Bit16 *)&p_p->Low.nf_ASN = ntohs(fr5->src_as);
         *(Bit16 *)&p_p->High.nf_ASN = ntohs(fr5->dst_as);
#endif
         p_p->Low.nf_ASN = fr5->src_as;  /* Network byte order */
         p_p->High.nf_ASN = fr5->dst_as;
         p_p->Low.nf_mask = fr5->src_mask;
         p_p->High.nf_mask = fr5->dst_mask;

         p_p->if_nbr = p_p->ntm_interface = pi->nbr;  /* 28 Mar 04 */
               /* Remember interface from -i option */
         make_stream_for_pkt(p_p);
         process_pkt(p_p);
         }
      }
   else {
      log_msg(LOG_ERR, 0, 
         msg, "nf_read(%s): NF version %d ???", pi->name, nf_version);
      return;
      }
   }

int init_interface(struct interface_info *pi)  /* NetFlow */
{
   int soc;
   struct sockaddr_in socadr;
   struct in_addr netid;
   ushort port;

   if (pi->name[0] == '\0') strcpy(pi->name, "9996");
   port = atoi(pi->name);

   /* Open a UDP port to the NetFlow router */
   socadr.sin_family = AF_INET;
   socadr.sin_addr.s_addr = htonl(INADDR_ANY);
   socadr.sin_port = htons(port);
   netid.s_addr = socadr.sin_addr.s_addr;

   if ((soc = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0) {
      log_msg(LOG_ERR, 0, "interface %d: couldn't get socket, errno %d\n",
         pi->nbr, (errno));
      return 0;  /* Fail */
      }
   /* Bind the socket */
   if (bind(soc, (struct sockaddr *)&socadr, sizeof(socadr)) < 0) {
      log_msg(LOG_ERR, 0, "interface %d: couldn't bind socket, errno %d\n",
         pi->nbr, (errno));
      return 0;  /* Fail */
      }

   sprintf(pi->name, "udp-%u", port);
   pi->fd = soc;

   pi->nf_buf = (char *)malloc(MAX_FLOW_PAK_SIZE);
   return 1;  /* OK */
   }

unsigned int pkt_counts(int reset)
{
   int j;
   struct interface_info *pi;

   if (reset) {
      npackets_org = pkts;  lostpackets_org = drops;
      }
   pkts = drops = 0L;  /* Get total packets seen and dropped */
   for (j = 0; j != n_interfaces; ++j) {
      pi = pci[j];
      pkts += pi->ipackets;  drops += pi->idrops;
      }
   npackets = pkts - npackets_org;
   lostpackets = drops - lostpackets_org;
   return 1;
   }
 
#elif CR_DATA  /* !NF_CISCO_DATA */

/* ===== Interface code using CoralReef to get packet headers ===== */

#define MERGE_TEST  0

#define MX_TS_JUMP  10000000  /* in us, i.e. 10 seconds */

int tv_diff_us(struct timeval x, struct timeval y)
{  /* Returns x-y microseconds, **assuming y >= x** */
   int s,u;
   s = x.tv_sec - y.tv_sec;
   if ((u = x.tv_usec - y.tv_usec) < 0) {
      --s;  u += 1000000;
      }
   return s*1000000 + u;
   }

int waiting_live_source = -1;

int select_us = 4*MN_SELECT_US;
struct timeval select_tv = {0,4*MN_SELECT_US};
#define MX_NODATA_READS  50  /* Don't wait too long! */

void handle_coral_packet(int src_nbr,
   coral_pkt_buffer_t *header, coral_pkt_buffer_t *packet)
{
   union atm_hdr atm_h;
   coral_llcsnap_t *snap_h;
   coral_pkt_buffer_t payload;
   struct ether_hdr *ethp;
   struct llc *llcp;
   unsigned int ether_type, lsap, atype;
   Bit8 *p;
   struct ether_hdr ehdr;
   struct pkt pmp;

   switch (packet->protocol) {
   case CORAL_DLT_ATM_RFC1483:
   case DLT_ATM_CLIP:
      atm_h.ui = ntohl(*(Bit32 *)header->buf);
      snap_h = (coral_llcsnap_t *)packet->buf;
      if (coral_get_payload(packet, &payload) < 0) { 
         log_msg(LOG_INFO, 0, "coral_get_payload failed");
         return;
         }
      if (adj_reqd) {  /* Don't do this unless we have to! */
         /* Use UNI VPI and VCI as low 3 bytes of MAC address.
            Put it in both source and dest so that rulesets
            which test only one will work as expected */
         *(Bit16 *)&ehdr.dest[0] = *(Bit16 *)&ehdr.source[0] = 0;
         *(Bit32 *)&ehdr.dest[2] = *(Bit32 *)&ehdr.source[2] = atm_h.h.vpvc; 
         }
      ether_type = ntohs(snap_h->snap_type);  lsap = 0xAAAA;
      ethp = &ehdr;  p = (Bit8 *)payload.buf;  atype = AT_AAL5;
      break;
   case CORAL_DLT_ATM_AAL5:
      log_msg(LOG_ERR, 0, "coral_packet(): ATM_AAL5 unimplemented");
      return;
   case CORAL_DLT_LANE_IEEE8023:
      log_msg(LOG_ERR, 0, "coral_packet(): LANE_IEEE8023 unimplemented");
      return;
   case CORAL_DLT_EN10MB:
      ethp = (struct ether_hdr *)packet->buf;
      ether_type = ntohs(ethp->type);
      if (coral_get_payload(packet, &payload) < 0) {
         log_msg(LOG_INFO, 0, "coral_get_payload failed");
         return;
         }
      lsap = 0xAAAA;
      p = (Bit8 *)payload.buf;  atype = AT_ETHERNET;
      break;
   case CORAL_DLT_IEEE802:
      ethp = (struct ether_hdr *)packet->buf;
      if (coral_get_payload(packet, &payload) < 0) {
         log_msg(LOG_INFO, 0, "coral_get_payload failed");
         return;
         }
      p = (Bit8 *)payload.buf;
      llcp = (struct llc *)p;
      lsap = llcp->dsap << 8 | llcp->ssap;
      if (lsap == 0xAAAA) {  /* SNAP packet */
         ether_type = ntohs(*(Bit16 *)llcp->ctl.snap_ether.snap_ethertype);
         p += sizeof(struct llc);
         }
      else ether_type = 0;  /* Other 802.2 packet */
      atype = AT_ETHERNET;
      break;
   case CORAL_DLT_GIGX:
      log_msg(LOG_ERR, 0, "coral_packet(): GIGX unimplemented");
      return;
   default:
#if 0
      { int j;  Bit8 *p8 = (Bit8 *)packet->buf;
         for (j = 0; j != 40; ++j) printf(" %02x", p8[j]);
         printf("\n");
         }
      log_msg(LOG_ERR, 0,
         "coral_packet(): unknown protocol %d", packet->protocol);
#endif
      return;
      }

   pmp.p_len = 0;  /* use_ip_length will get length from IP header */
   if (handle_pkt(&pmp, ether_type,lsap,
         (unsigned char *)ethp, p, payload.caplen)) {
      pmp.Low.Interface = htons(src_nbr+1);  /* 1-org */
      pmp.Low.Interface = 0;
      pmp.Low.AdjType = atype;  pmp.High.AdjType = 0;
      pmp.arrival_time = microseconds(last_ts);  /* struct timeval */
      pkt_monitor(&pmp);
      }
   }

int read_live_block(int);

void bad_ts_msg(char *msg, struct interface_info *pi,
   struct timeval ts, struct timeval tb, char *comment)
   /* ts = last good timestamp, tb = timestamp from buffer.
      diff (as printed) = tb - ts */
{
   int d = tv_diff_us(tb,ts)/1000000;
   char b_ts[30], b_tb[30];
   fmt_ts(b_ts, ts);  fmt_ts(b_tb, tb);
   log_msg(LOG_ERR, 0, "%s i/f %d: cells=%u/%u, %s-%s, diff=%ds%s",
      msg, pi->nbr, pi->ncells,pi->icells, b_ts,b_tb, d, comment);
   }

int ts_seq_ok(struct timeval ts, struct timeval tb)
{
   int td = tv_diff_us(tb,ts);
   if (td < 0) td = -td;
   return td <= MX_TS_JUMP;
   }

coral_merge()
{
   struct timeval ts, mints;
   int j, minj, tsec, n;
   struct interface_info *pi;
   coral_pkt_buffer_t outer, hdr;
   char nbt[60];

   pi = pci[0];
   fmt_ts(nbt, pi->card_ts);
   for (;;) {
      mints = pci[0]->card_ts;  minj = 0;
      for (j = 1; j != n_interfaces; ++j) {  /* Find min timestamp */
         ts = pci[j]->card_ts;
         if ((ts.tv_sec == mints.tv_sec && ts.tv_usec <= mints.tv_usec)
               || ts.tv_sec < mints.tv_sec) {
            mints = ts;  minj = j;
            }
         }
      pi = pci[minj];
      last_ts = mints;  /* Used by uptime() routines */

      if (--pi->sample_count == 0) {  /* Process only 1 pkt per SampleRate */
         pi->sample_count = pi->SampleRate;

         if (coral_cell_to_pkt(pi->iface, pi->cellp, &hdr)) {
               /* Dummy up an RFC1483 packet */
            outer.protocol = CORAL_DLT_ATM_RFC1483;
            outer.buf = (Bit8 *)coral_cell_header(pi->iface, pi->cellp);
            handle_coral_packet(pi->nbr, &outer, &hdr);
            }
         }

      ++pi->ipackets;  /* For global statistics */

      if (--pi->ncells == 0) {
         waiting_live_source = minj;
         return;  /* Keep outer block alive */
         }
      else {
         pi->cellp += coral_cell_size(pi->iface);
         CORAL_TIMESTAMP_TO_TIMEVAL(pi->iface, 
            coral_cell_time(pi->iface, pi->cellp), &ts);
         if (ts_seq_ok(mints, ts)) {
            pi->card_ts = ts;  /* Timestamp looks OK */
	    }
         else {  /* Bad timestamp, look through block for a good one */
            for (n = pi->ncells;  pi->ncells != 0;  --pi->ncells,
                  pi->cellp += coral_cell_size(pi->iface)) {
               CORAL_TIMESTAMP_TO_TIMEVAL(pi->iface, 
                  coral_cell_time(pi->iface, pi->cellp), &ts);
               if (ts_seq_ok(mints, ts))
                  break;  /* Found a likely timestamp  */
               ++pi->badtspkts;
               }
            if (pi->ncells == 0) {  /* Ignore bad pkts at end of buffer */
               sprintf(nbt, ": %d pkts ignored (end of buffer)", n);
               bad_ts_msg("**T", pi, mints, ts, nbt);
               pi->idrops += n;
               waiting_live_source = minj;
               return;  /* Keep outer block alive */
               }
            else {  /* Ignore bad pkts within buffer */
               sprintf(nbt, ": %d pkts ignored (within buffer)", n-pi->ncells);
               bad_ts_msg("*T*", pi, mints, ts, nbt);
               pi->idrops += n-pi->ncells;
               pi->card_ts = ts;  /* Change timestamp */
               }
            }
         }
      }
   }


int read_live_block(int i)
{
   struct interface_info *pi = pci[i];
   coral_iface_t *iface;
   coral_blk_info_t *binfop;
   coral_atm_cell_t *cellp;
   struct timeval ts;
   char g_ts[30], b_ts[30];

   errno = 0;  /* System call error variable */
   if ((iface = coral_read_block(pi->crl_src, &binfop, &cellp,
         &select_tv)) == NULL) {
      if (errno != pi->last_errno) {
         if (errno != EAGAIN) log_msg(LOG_ERR, 0,
            "if_read(1): i/f %d, error %d (%s)",
            pi->nbr, errno, strerror(errno));
         pi->last_errno = errno;
         }
      /* NOTE: The Coral Dag driver doesn't return partial blocks,
               we have to sit around waiting until we get 16384
               cells on an interface, which can take several
               seconds on a link which doesn't have much traffic! */
      if (++pi->empty > MX_NODATA_READS) {
         /* Guess lowest ts for next pkt */
         tv_add(pi->card_ts,select_tv);
         pi->empty = 0;
         if (!pi->no_data_warned) {
            fmt_ts(g_ts, pi->card_ts);
            log_msg(LOG_WARNING, 0,
               "i/f %d, no data, ts set to %s", pi->nbr, g_ts);
            pi->no_data_warned = 1;
            }
         }
      return 0;  /* Try again */
      }
   else {  /* Data bytes read */
      pi->no_data_warned = pi->last_errno = 0;
      pi->iface = iface;  pi->cellp = cellp;
      pi->icells = pi->ncells = ntohl(binfop->cell_count);
      pi->idrops += ntohl(binfop->cells_lost);
#if MERGE_TEST == 2
      printf("\nif_read(2): blocks=%d, icells=%d", pi->nblocks,pi->icells);
#endif

      CORAL_TIMESTAMP_TO_TIMEVAL(pi->iface, 
         coral_cell_time(pi->iface, pi->cellp), &ts);
      if (pi->nblocks == 0 ||  /* Just getting started */
            pi->empty != 0 ||  /* Had some no_data reads */
            ts_seq_ok(pi->card_ts, ts)) {
         pi->card_ts = ts;  /* Timestamps OK between blocks */
         }
      else {  /* Bad timestamp at start of block */
         fmt_ts(g_ts, pi->card_ts);  fmt_ts(b_ts, ts);
         log_msg(LOG_ERR, 0,
            "nif_read(5): i/f %d, block %d, %d cells, %s -> %s, "
               "bad ts at start of block !!!!!",
               pi->nbr, pi->nblocks, pi->ncells, g_ts, b_ts);
         pi->idrops += pi->icells;
         ++pi->badtspkts;
         return 0;
         }

      ++pi->nblocks;  pi->tcells += pi->ncells;
#if MERGE_TEST >= 1
      fmt_ts(b_ts, pi->card_ts);
      printf("\nif_read(7): i/f %d, ts=%s, %d ncells, %d nblocks\n", 
         pi->nbr, b_ts, pi->ncells, pi->nblocks);
#endif
      }
   return 1;
   }

void init_live_sources(void)
{
#define STARTUP_TRIES  2000  /* There may not be very much traffic */
   int j,n,b;
   struct timeval ts;

   sleep(10);  /* Wait until we get a full buffer */
   for (j = 0; j != n_interfaces; ++j)
      pci[j]->nblocks = 0;
   for (n = 0; n != STARTUP_TRIES; ++n) {
      for (j = 0; j != n_interfaces; ++j) {  /* Get block for each source */
         read_live_block(j);
         }
      for (b = j = 0; j != n_interfaces; ++j)
         if (pci[j]->nblocks != 0) ++b;
      if (b == n_interfaces) break;
      }

   if (n == STARTUP_TRIES) log_msg(LOG_ERR, 98,
      "init_live_sources(): couldn't get data from interface(s)");

   meter_start_time = pci[0]->card_ts;  /* Set to min Coral timestamp */
   for (j = 1; j != n_interfaces; ++j) {
      ts = pci[j]->card_ts;
      if (ts.tv_sec == meter_start_time.tv_sec &&
            ts.tv_usec <= meter_start_time.tv_usec)
         meter_start_time = ts;
      else if (ts.tv_sec < meter_start_time.tv_sec)
         meter_start_time = ts;
      }
   last_ts = meter_start_time;
   start_uptime_clock();
   printf("init_live_sources(): first blocks read\n");
   fflush(stdout);
   }

int interface_read_trace(struct interface_info *pi)  /* Coral */
{
   coral_iface_t *iface;
   coral_pkt_result_t pkt_result;
   coral_interval_result_t interval_result;
   int src_nbr, save_lts;

   if ((iface = coral_read_pkt(&pkt_result, &interval_result)) == NULL) {
      if (errno == 0) {  /* End of trace file  or  stopped device */
         show_memory();
         show_stream_hash();
         }
      else
         log_msg(LOG_ERR, 0, "coral_read_pkt() failed, %s", strerror(errno));
      return 0;  /* Signals EOF to non-live loop */
      }
   else {
      src_nbr = coral_source_get_number(coral_interface_get_src(iface));
      if (pkt_result.packet != NULL) {  /* We have a packet */
         ++pi->ipackets;  /* For global statistics */

         CORAL_TIMESTAMP_TO_TIMEVAL(iface, pkt_result.timestamp, &last_ts);
         pi->sample_count = pi->SampleRate;

         save_lts = last_t_sec;

         handle_coral_packet(src_nbr,
            pkt_result.header, pkt_result.packet);

         if (!live_source &&  /* Reading a trace file */
               last_t_sec > save_lts) {
            --trace_count == 0;
            }
         }
      else if (interval_result.stats == NULL) {  /* Coral interval has begun */
         last_ts = interval_result.begin;
	 }
      else {  /* A Coral interval has ended **or** we've reached EOF !!! */
         pi->ipackets += interval_result.stats->pkts_recv;
         pi->idrops += interval_result.stats->pkts_drop;

         printf("End(%d): ts=%d.%03d, active=%u, new=%d, recov=%u, "
               "(GC: %u s, %u flow), pkts=%d, streams=%d\n",
            trace_count, last_ts.tv_sec,last_ts.tv_usec/1000, active_flows(),
            FlowsCreated, FlowsRecovered,
            gc_interval, gc_f,
            mxpktdatas-n_free_pktdata, mxstreams-n_free_streams);
         zero_stats(0);

         last_ts = interval_result.end;
         if (last_ts.tv_sec != last_t_sec)
            --trace_count;  /* Tell receive() loop we're at interval end */
         }         
      }
   return 1;
   }

char *cs_type(int cst)
{
   switch (cst) {
   case CORAL_TYPE_FILE:
      return "CoralReef file";
   case CORAL_TYPE_PCAP:
      return "tcpdump file";
   case CORAL_TYPE_DAGFILE:
      return "Dag file";
   case CORAL_TYPE_TSH:
      return "tsh file";
   case CORAL_TYPE_NONE:
      return "Invalid or Unknown";
   case CORAL_TYPE_FATM:
       return "FORE card";
   case CORAL_TYPE_POINT:
      return "POINT card";
   case CORAL_TYPE_DAG:
      return "DAG card";
   case CORAL_TYPE_PCAPLIVE:
      return "pcap interface";
   default:
      return "Bad cs_type";
      }
   }

int init_interface(struct interface_info *pi)  /* CoralReef */
{
   int src_nbr,src_type, if_nbr, info_len, len, ir;
   time_t ct, min_ct;
   char buf[150], *bp, *crl_info_string;
   coral_source_t *i_src;
   struct timeval c_interval;

   coral_iface_t *iface; int ifn, ift; time_t cap_time;

   if (pi->nbr == 1) {  /* Handling first CoralReef source */
      coral_set_options(0, CORAL_OPT_NORMALIZE_TIME);
      /* We want timestamps in Unix epoch across all sources */
      }
   if (coral_open(i_src = pi->crl_src) < 0) {
      log_msg(LOG_ERR, 0, "coral_open(%s) failed", pi->name);
      return 0;  /* Fail */
      }

   src_nbr = coral_source_get_number(i_src);
   if (src_nbr != pi->nbr-1)
      log_msg(LOG_ERR, 0, "src_nbr(%d) != pi->nbr(%d)", src_nbr,pi->nbr-1);

   src_type = coral_source_get_type(i_src);
   switch (src_type) {
   case CORAL_TYPE_FILE:   /* CoralReef trace file */
   case CORAL_TYPE_PCAP:   /* pcap (tcpdump) trace file */
   case CORAL_TYPE_DAGFILE:
   case CORAL_TYPE_TSH:
   case CORAL_TYPE_NONE:   /* Invalid or unknown */
   default:
      sprintf(pi->name, "crl%d (%s)", src_nbr, cs_type(src_type));
      pi->adjtype = AT_TRACE;  /* Don't know original interface type */
      live_source = 0;
      break;
   case CORAL_TYPE_FATM:   /* FORE OC3 card */
   case CORAL_TYPE_POINT:  /* Apptel POINT card */
   case CORAL_TYPE_DAG:    /* DAG card */
   case CORAL_TYPE_PCAPLIVE:
      sprintf(pi->name, "%s (%s)",
         coral_source_get_filename(i_src), cs_type(src_type));
      pi->adjtype = AT_ATM;
      live_source = 1;
      break;
      }

   if (pi->nbr == n_interfaces) {  /* Handling last CoralReef source */
      log_msg(LOG_INFO, 0, "%d coral interfaces opened", n_interfaces);
      if (coral_start_all() < 0) {  /* Also synchronises all sources */
         log_msg(LOG_ERR, 0, "coral_start failed");
         return 0;  /* Fail */
         }

     if (!live_source) {
         cap_time = 0;  iface = NULL;
         do {
            iface = coral_next_interface(iface);
            if (iface != NULL) {
               if_nbr = coral_interface_get_number(iface);
               ct = coral_interface_get_capturetime(iface);
               if (if_nbr == 0) min_ct = ct;
               else if (ct < min_ct) min_ct = ct;
               }
            } while (iface != NULL);

         sprintf(buf, "%d  source file %s  cap_time %u ", trace_interval,
            coral_source_get_filename(i_src), min_ct);
         info_len = strlen(buf);  bp = &buf[info_len];

         cap_time = 0;  iface = NULL;
         do {
            iface = coral_next_interface(iface);
            if (iface != NULL) {
               if_nbr = coral_interface_get_number(iface);
               src_type = coral_interface_get_type(iface);
               cap_time = coral_interface_get_capturetime(iface);
               sprintf(bp, " (i/f %d %s %d)",
                  if_nbr, cs_type(src_type), cap_time);
               len = strlen(bp);  bp += len;  info_len += len;
               }
            } while (iface != NULL);
         if (info_len > sizeof(buf))
	    log_msg(LOG_ERR, 1, "NeTraMet Coral info string overflow !!!");
         crl_info_string = (char *)malloc(info_len+1);
         strcpy(crl_info_string, buf);
         crl_info = crl_info_string;
            /* NeMaC writes this to a #CoralReef record */
         }
      else {  /* Live source */
         cap_time = 0;  iface = NULL;
         do {
            iface = coral_next_interface(iface);
            if (iface != NULL) {
               if_nbr = coral_interface_get_number(iface);
               ct = coral_interface_get_capturetime(iface);
               if (if_nbr == 0) min_ct = ct;
               else if (ct < min_ct) min_ct = ct;
               }
            } while (iface != NULL);
         last_t_sec = meter_start_time.tv_sec = min_ct;
         meter_start_time.tv_usec = 0;
         }
 
      if (!live_source) {
         if (trace_interval <= 0) {
            printf("No meter reading interval specified (-T option)\n");
            log_msg(LOG_ERR, 0,
               "No meter reading interval specified (-T option)");
            return 0;  /* Fail */
            }

         c_interval.tv_sec = trace_interval;  c_interval.tv_usec = 0;
         if ((ir = coral_read_pkt_init(NULL, NULL, &c_interval)) != 0) {
                                         /* For one_second_process() */
            log_msg(LOG_ERR, 0,
               "coral_read_pkt_init failed, result=%d", ir);
            return 0;  /* Fail */
            }
         /* We only want one interval per second, not one per source */
         trace_count = trace_interval;
         crl_n_count = 0;
         }
      }

   return 1;  /* OK */
   }

unsigned int pkt_counts(int reset)  /* Get total packets seen and dropped */
{              /* 'Source' counters updated at end of CoralReef intervals */
   int j;
   struct interface_info *pi;

   if (reset) {
      npackets_org = pkts;  lostpackets_org = drops;
      }

   pkts = drops = 0L;
   for (j = 0; j != n_interfaces; ++j) { /* One NetraMet interface per source */
      pi = pci[j];
      pkts += pi->ipackets;  drops += pi->idrops;
      }
   npackets = pkts - npackets_org;
   lostpackets = drops - lostpackets_org;
   return 1;
   }

#elif LFAP_METER /* !NF_CISCO_DATA && !CR_DATA */

int    lfap_server_socket;
int    lfap_info_level = 0;
int    lfap_keepalive_interval = 30; /* in seconds */
char		lfap_community[SZ_IFNAME];
struct sockaddr_in	lfap_server_addr;
val64  fasPrefix;

int    handleVR(struct interface_info *pi);
int    handleFAR(struct interface_info *pi);
int    handleFUN(struct interface_info *pi);
int    handleAR(struct interface_info *pi);
int    handleARA(struct interface_info *pi);
void   processMessage(struct interface_info *pi);
void   handleChangedFlows(struct interface_info *pi);
void   removeFlow(struct interface_info *pi, int flownr);

void   tick(struct interface_info *pi);

int    start_lfap(struct utsname *name);
  
#include "lfapmet.c"  /* Too much code to keep in this file! */

#elif DAG_DATA  /* !NF_CISCO_DATA && !CR_DATA && !LFAP_METER */

   /* ===== Dag ADSL (via input pipe)  interface code ===== */

/* DAG_ADSL should select this format for the Dag data ... */

struct adsl_rec {
   long long ts;     /* Dag timestamp (64-bit) */
   Bit32 atm_hdr;    /* First byte 0x01 or 00: packet direction */
   Bit8 stuff[32];   /* PPPoE bridged over AAL5 stuff */
   Bit8 ip_hdr[64];  /* First 64 bytes of IP packet */
   };

#if 0
ts=0x3a94c97f2708f900 atm=0x00a00660
0xaaaa0300 0x80c20007 0x0000   0090 0x3935403f
                               Concentrator MAC addr
0x00d0590d 0x325b 8864 0x1100  0066 0x05ae  0021
   Host MAC addr  PPPoE  vt   SessID   len   PPP protocol
0x450005ac 0x42964000 0x4006d73e 0x0a64034a  PPP payload
0x0ac80302 0x08830014 0x0abf8a22 0x00545b09
0x50107edc 0xb8ce0000 0xecfe1d19 0xa5da1b3c
pkt0x3c334000 0x0001121a 0x8be23cfa 0x3683523c
#endif

void handle_adsl_record(struct interface_info *pi,
   struct adsl_rec *a_buf)
{
   struct timeval tv;
   struct pkt pp;
   struct ether_hdr ehdr;
   Bit32 ah;  Bit8 dirn;

/*   printf("ts=%qx atm=%lx\n", a_buf->ts, a_buf->atm_hdr);  */

   tv.tv_sec = (long)(a_buf->ts >> 32);
   tv.tv_usec = ((a_buf->ts & 0xffffffffLL) * 1000000) >> 32;

   if (--pi->sample_count == 0) {  /* Process only 1 pkt per SampleRate */
      pi->sample_count = pi->SampleRate;

      ah = ntohl(a_buf->atm_hdr);
      dirn = *(Bit8 *)&ah;  /* 0 or 1, indicates dag0 or dag1 */
      if (adj_reqd) {
         ehdr.source[0] = ehdr.source[1] = 0;
         memcpy(&ehdr.source[3], (Bit8 *)&ah + 1, 3);
         memcpy(&ehdr.dest, &ehdr.source, MAC_ADDR_LEN);
         if (dirn) {
            ehdr.source[2] = 2;  ehdr.dest[2] = 1;
            }
         else {
            ehdr.source[2] = 1;  ehdr.dest[2] = 2;
            }
         }

      if (handle_pkt(&pp, 0x0800, 0xAAAA, (Bit8 *)&ehdr,
            /* Will need to work out what eth_type/lsap should be */
            a_buf->ip_hdr, 64)) {
         pbp->Low.AdjType = AT_PPP;  /* Generic PPP */
         pbp->High.AdjType = 0;
         pp.Low.Interface = htons(dirn ? 2 : 1);
         pp.High.Interface = 0;
         pp.arrival_time = microseconds(tv);
         pkt_monitor(&pp);
         }
      }
   }

Bit8 a_b[sizeof(struct adsl_rec)];  /* ADSL record buffer */
int n_b = 0;  /* Bytes already in a_b */

void interface_read(struct interface_info *pi)
{
   int n, r;

   for (n = 20; n != 0; --n) {
      if ((r = read(pi->fd, &a_b[n_b], sizeof(struct adsl_rec)-n_b)) <= 0) {
         if (errno == EAGAIN) {
            return;  /* No more data in pipe */
            }
         else {
            log_msg(LOG_ERR, 0, "adsl_read(): %s\n", strerror(errno));
            return;
            }
          }
      else {
         n_b += r;
         if (n_b != sizeof(struct adsl_rec))
            return;  /* Wait for rest of record */
         }

      handle_adsl_record(pi, (struct adsl_rec *)a_b);
      n_b = 0;
      }
   }

int init_interface(struct interface_info *pi)  /* Dag ADSL */
{
   int fd, flags;

   if (strcmp(pi->name,"stdin") == 0) {
      fd = dup(STDIN_FILENO);
      close(STDIN_FILENO);
      if (kb_enabled) {
         if (open("/dev/tty", O_RDONLY) != 0) {
            log_msg(LOG_ERR, 0,
               "adsl_open(%s): coudn't open /dev/tty, %s\n", 
               pi->name, strerror(errno));
            exit(1);
            }
         }
      }
   else if ((fd = open(pi->name, O_RDONLY)) < 0) {
      log_msg(LOG_ERR, 0, "adsl_open(%s): %s\n", pi->name, strerror(errno));
      return 0;  /* Fail */
      }

   if ((flags = fcntl(fd, F_GETFL, 0)) < 0) {
      log_msg(LOG_ERR, 0, "adsl_open(%s): fcntl get failed\n", pi->name);
      return 0;  /* Fail */
      }
   flags |= O_NONBLOCK;
   if (fcntl(fd, F_SETFL, flags) < 0) {
      log_msg(LOG_ERR, 0, "adsl_open(%s): fcntl set failed\n", pi->name);
      return 0;  /* Fail */
      }

   pi->fd = fd;
   return 1;  /* OK */
   }

unsigned int pkt_counts(int reset)
{
   if (reset) {
      npackets_org = pkts;  lostpackets_org = drops;
      }
   pkts = drops = 0L;  /* Get total packets seen and dropped */
   return 1;
   } 

/* ===== End of ADSL interface code ===== */

#elif DAG_DIRECT  /* !NF_CISCO_DATA && !CR_DATA && !LFAP_METER && !ADSL_DATA */

/* ===== Dag direct interface code ===== */

#include <fcntl.h>

#define MERGE_TEST  0

#define MX_CONSEC_BADTS  25
   /* Shut down meter after this many bad timestamps */

#define MX_TS_JUMP      2  /* Seconds */

int waiting_live_source = -1;

int select_us = 4*MN_SELECT_US;
long long select_time;
#define MX_NODATA_READS  100

#if PKT_DEBUG > 1
int n_rdr_pr = 0;
#endif

struct pkt *pkt_from_dag_record(struct dag_rec *drp,
   struct interface_info *pi)
{
   Bit32 ah, vpvcmask;
   struct snap_hdr *sh;
   struct ether_hdr ehdr, *eh;
   Bit8 *p;  int x,rec_len;
   Bit16 lsap, ether_type;
   int t, r;
   struct pkt *p_p;

   if ((p_p = get_pkt()) == NULL) {
      ++pi->idrops;
      return NULL;  /* No free pkts, drop the record */
      }
# if PKT_DEBUG
   if (p_p->pkt_state != 1) {
      printf("pkt_from_dag(1): not got, p_p=%x\n", p_p);  fflush(stdout);
      quack(401);
      }
# endif
# if PKT_DEBUG > 1
   printf("rdr(%x) ", p_p);
   if (++n_rdr_pr == 8) { printf("\n");  n_rdr_pr = 0; }
   fflush(stdout);
# endif

# if 0
   { char tsb[50];
   fmt_ts(tsb, drp->ts);  /**/
     log_msg(LOG_ERR, 0, "thd(%d): ts=%s, ncells=%d",
	     pi->nbr, tsb, pi->ncells); } /**/
# endif

   p_p->arrival_time = microseconds(drp->ts);
   if (adj_reqd) memset(&ehdr, 0, sizeof(struct ether_hdr));
   p_p->if_nbr = pi->nbr;
# if NO_MERGE_THREAD
   p_p->hash_group = pi->nbr;
# endif
   p_p->n_ports = pi->dag_ports;

# if PKT_DEBUG
   if (p_p->pkt_state != 1) {
      printf("pkt_from_dag(2): not got, p_p=%x\n", p_p);  fflush(stdout);
      quack(402);
      }
# endif
   if (pi->dag_type == TT_EXT) {  /* 'Extensible' Dag card */
      p_p->port_nbr = drp->d.ext.flags & DF_INTERFACE;
      p_p->datagram_len = p_p->p_len =
         ntohs(drp->d.ext.wlen);  /* On-the-wire length */

      if ((t = drp->d.ext.type) == TYPE_HDLC_POS) {
         p_p->adj_type = AT_SONET;
	 x = drp->d.ext.e.pos.pload - (Bit8 *)drp;
         rec_len = ntohs(drp->d.ext.rlen) - x;  /* Bytes in Dag record */
	 p_p->datagram_len -= x;
         r = handle_pkt(p_p, ntohs(drp->d.ext.e.pos.etype), 0, (Bit8 *)&ehdr,
            drp->d.ext.e.pos.pload, rec_len);
         }
      else if (t == TYPE_ETH) {
         p_p->adj_type = AT_ETHERNET;
	 x = drp->d.ext.e.eth.pload - (Bit8 *)drp;
         rec_len = ntohs(drp->d.ext.rlen) - x;  /* Bytes in Dag record */
	 p_p->datagram_len -= x;
         p = drp->d.ext.e.eth.pload;
         eh = &drp->d.ext.e.eth.eh;
         if ((ether_type = ntohs(eh->type)) <= 1500) {  /* 802.3 packet */
            sh = (struct snap_hdr *)p;
            if ((lsap = ntohs(sh->lsap)) == 0xAAAA) {  /* SNAP packet */
               ether_type = ntohs(sh->etype);
               p += sizeof(struct snap_hdr);
               rec_len -= sizeof(struct snap_hdr);
               p_p->datagram_len -= sizeof(struct snap_hdr);
               }
            else ether_type = 0;  /* Other 802.2 packet */
            }
         else lsap = 0;  /* Blue book packet */
         r = handle_pkt(p_p, ether_type, lsap, (Bit8 *)&ehdr, p, rec_len);
//    printf("pfd(): ts=%u.%06u, port=%d, et=%04x, lsap=%04x, r=%d <==\n", 
//        DAGT_S(drp->ts), DAGT_US(drp->ts), p_p->port_nbr,
//        ether_type, lsap, r);  fflush(stdout);  //28
         }
      else if (t == TYPE_ATM) {
         p_p->adj_type = AT_AAL5;
	 x = drp->d.ext.e.atm.pload - (Bit8 *)drp;
         rec_len = ntohs(drp->d.ext.rlen) - x;  /* Bytes in Dag record */
	 p_p->datagram_len -= x;
         ah = ntohl(drp->d.ext.e.atm.atm_hdr);
         vpvcmask = 0x0ffffff0;	 /* VPI 8 bits, VCI 16 bits */
         ah &= vpvcmask;  ah >>= 4;
         sh = &drp->d.ext.e.atm.sh;
         if ((lsap = ntohs(sh->lsap)) == 0xAAAA) {  /* SNAP packet */
            ether_type = ntohs(sh->etype);
# if MERGE_TEST == 2
            printf("%d", pi->nbr); /* */
# endif
             }
         else {
            ether_type = ntohs(sh->etype);
            }
         r = handle_pkt(p_p, ether_type, lsap, (Bit8 *)&ehdr,
            drp->d.ext.e.atm.pload, rec_len);
         }
      }
   else if (pi->dag_type == TT_POS) {  /* TYPE_LEGACY packets .. */
# if MERGE_TEST == 2
      printf("%d", pi->nbr); /* */
# endif
      p_p->port_nbr = 0;
      p_p->p_len = ntohs(drp->d.pos.wlen);  /* On-the-wire length */
      p_p->adj_type = AT_SONET;
      r = handle_pkt(p_p, ntohs(drp->d.pos.etype), 0, (Bit8 *)&ehdr,
         drp->d.pos.pload, sizeof(drp->d.pos.pload));
      }
   else if (pi->dag_type == TT_ATM) {
      ah = ntohl(drp->d.atm.atm_hdr);
      vpvcmask = 0x0ffffff0;	 /* VPI 8 bits, VCI 16 bits */
      ah &= vpvcmask;  ah >>= 4;
      /* printf("ts=%qx (%u.%06u), atm=%06x (%08x) ",
         drp->d.atm.ts,
         DAGT_S(drp->d.atm.ts),DAGT_US(drp->d.atm.ts),
         ah, ntohl(drp->d.atm.atm_hdr)); /* */

      sh = &drp->d.atm.sh;
      if ((lsap = ntohs(sh->lsap)) == 0xAAAA) {  /* SNAP packet */
         ether_type = ntohs(sh->etype);
# if MERGE_TEST == 2
          printf("%d", pi->nbr); /* */
# endif
          }
      else {
         ether_type = ntohs(sh->etype);
         /* printf("\natm=%06x: ", 
            ah, lsap, ether_type);
         snp = (Bit8 *)&drp->d.atm.sh;
         for (j = 0; j != 24; ++j) printf(" %02x", snp[j]);
         printf("\n");  /* --- */
         /* Will need to work out what eth_type/lsap should really be! */
         }

      p_p->port_nbr = 0;
      p_p->p_len = 48;  /* Guess it's one ATM cell (!) */
         /* use_ip_len set by default in main() */
      p_p->adj_type = AT_AAL5;
      r = handle_pkt(p_p, ether_type, lsap, (Bit8 *)&ehdr,
         drp->d.atm.pload, sizeof(drp->d.atm.pload));
      }
   else if (pi->dag_type == TT_ETHER) {
# if MERGE_TEST == 2
      printf("%d", pi->nbr); /* */
# endif
      p = drp->d.eth.pload;
      rec_len = sizeof(drp->d.eth.pload);
      eh = &drp->d.eth.eh;
      if ((ether_type = ntohs(eh->type)) <= 1500) {  /* 802.3 packet */
         sh = (struct snap_hdr *)p;
         if ((lsap = ntohs(sh->lsap)) == 0xAAAA) {  /* SNAP packet */
            ether_type = ntohs(sh->etype);
            p += sizeof(struct snap_hdr);
            rec_len -= sizeof(struct snap_hdr);
            p_p->datagram_len -= sizeof(struct snap_hdr);
            }
         else ether_type = 0;  /* Other 802.2 packet */
         }
      else lsap = 0;  /* Blue book packet */

      p_p->port_nbr = 0;
      p_p->p_len = ntohs(drp->d.eth.wlen);  /* On-the-wire length */
      p_p->adj_type = AT_ETHERNET;
      r = handle_pkt(p_p, ether_type, lsap, (Bit8 *)eh, p, rec_len);
      }
   /*  for (j = 8; j != 24; ++j) printf(" %02x", drp->pload[j]);
	      printf(" ");  /* */
# if PKT_DEBUG
   if (p_p->pkt_state != 1) {
      printf("pkt_from_dag(3): not got, p_p=%x\n", p_p);  fflush(stdout);
      quack(403);
      }
# endif
// //  free_pkt(p_p);  return NULL;  // //

   if (r) {
#if 0
      if (!live_source) {
            /* Assume trace file is dagmerge of *two* Dag files */
         /* Not any more, dd_ntm can merge two trace files!
            Need a command-line option to specify 'dag_merged file' */
         p_p->Low.Interface = 1;
# if 0 
         p_p->Low.Interface = htons(
            drp->ts & 0x1ULL);  /* LSB of timestamp */
# endif
         }
#endif

# if PKT_DEBUG
   if (p_p->pkt_state != 1) {
      printf("pkt_from_dag(4): not got, p_p=%x\n", p_p);  fflush(stdout);
      quack(404);
      }
# endif
      return p_p;
      }
   else {
# if PKT_DEBUG
      if (p_p->pkt_state == 0) {
         printf("handle_dag(): already free, p_p=%x\n", p_p);  fflush(stdout);
         }
# endif
# if 0  /* Look at packet rejected by handle_pkt() /**/
      if (running_rts != 0) {
         Bit8 *snp;  int j;
         printf("h-p_r(): r=%d, ether_type=%04x (%d), lsap=%04x\n   ",
            r, ether_type,ether_type, lsap);
         snp = (Bit8 *)&drp->d.atm.sh;
         for (j = 0; j != 48; ++j) printf(" %02x", snp[j]);
         printf("\n");
         fflush(stdout);
         }
# endif
# if PKT_DEBUG > 1
      printf(" rdr: rejected, p_p=%x\n", p_p);  fflush(stdout);
# endif
      free_pkt(p_p); 
      }
   return NULL;
   }

long long dag_ts_tol = US_DAGT(15);
/* Dag cards with >1 interface can queue records on one interface
   ahead of records on another interface.  This shows up as
   backward jumps in the sequence of timestamps from the card.
   dag_ts_tol is our max allowed backward time jump in microsends */

int next_dag_record(struct interface_info *pi);

int last_dag_flags = 0;  //23

void dag_merge()
{
   long long ts, mints;   /* Dag timestamp (64-bit) */
   int j, minj, starting, prev_badts = 0;
   int t_delta, save_lts = 0;
   struct interface_info *pi;
   struct pkt *pp;
#if MULTI
   Bit32 dag_merge_proct,
      last_dag_merge_proct = 0;
   struct tms tbuf;
#endif
   struct dag_rec *drp;
#if LOG_THREAD_PROCTIMES
   int this_tn = assign_thr_log_nbr();
   sprintf(thread_name[this_tn], "dag_merge");
   thread_proctime_org[this_tn] = thread_proctime[this_tn] = 0;
#endif   
#if TRACE_BADT_RECS
   char buf[30], buf2[30];
   long long ts_delta;
   
#endif
   for (;;) {
      minj = -1;
      for (j = 0; j < n_interfaces; ++j) {  /* May only be one interface */
         pi = pci[j];
         if (minj < 0) {
            mints = pi->dbp->ts;  minj = j;
            }
         else {
            ts = pi->dbp->ts;
            if (ts < mints) {
               mints = ts;  minj = j;
               }
            }
         }
      if (minj < 0) log_msg(LOG_ERR, 1, "No data on both i/fs <"); /**/
/*      printf("%d", minj);  fflush(stdout);  /**/

      pi = pci[minj];
      drp = pi->dbp;
      if (--pi->sample_count == 0) {  /* Process only 1 pkt per SampleRate */
         pi->sample_count = pi->SampleRate;
         save_lts = last_t_sec;

         if (mints < last_ts && (last_ts - mints >= dag_ts_tol)) {
               /* Backward time jump; ignore pkt */
               /* Can appear when reading from trace file */
#if TRACE_BADT_RECS
   ts_delta = last_ts - mints;
   fmt_ts(buf, mints);  fmt_ts(buf2, last_ts);
   log_msg(LOG_ERR, 0,
         "%s %s  -%d.%06d  %8d %10d.%06d:"
         " %02x-%02x:%02x %u %u %u  %u %u "
         " %02x %02x %02x %02x %02x %02x %02x %02x",
      buf2, buf, DAGT_S(ts_delta),DAGT_US(ts_delta),
         pi->ipackets, DAGT_S(pi->dbp->ts), DAGT_US(pi->dbp->ts),
      pi->dbp->d.ext.type, pi->dbp->d.ext.flags, last_dag_flags,
         ntohs(pi->dbp->d.ext.rlen),
         ntohs(pi->dbp->d.ext.lctr), ntohs(pi->dbp->d.ext.wlen),
        pi->dbp->d.ext.e.eth.offset, pi->dbp->d.ext.e.eth.pad,
      pi->dbp->d.ext.e.eth.pload[0], pi->dbp->d.ext.e.eth.pload[1],
         pi->dbp->d.ext.e.eth.pload[2], pi->dbp->d.ext.e.eth.pload[3],
         pi->dbp->d.ext.e.eth.pload[4], pi->dbp->d.ext.e.eth.pload[5],
         pi->dbp->d.ext.e.eth.pload[6], pi->dbp->d.ext.e.eth.pload[7] ); 
#endif
            ++pi->badtspkts;
            if (!live_source && !prev_badts) {
               printf(minj == 0 ? "*" : "+");  fflush(stdout);
               }
            prev_badts = 1;
            }
         else {
            pp = pkt_from_dag_record(drp, pi);
            if (pp != NULL) {  /* We have a packet */
# if PKT_DEBUG
   if (pp->pkt_state != 1) {
      printf("dag_merge(): not got, pp=%x\n", pp);  fflush(stdout);
      quack(501);
      }
# endif
               last_ts = mints;  /* Used by uptime() routines */
               t_pkt_monitor(pp);
               }
            prev_badts = 0;
            }
         }
      last_dag_flags = pi->dbp->d.ext.flags;  //23

//IP++      ++pi->ipackets;  /* For global statistics */
      ++pi->nrecords;  /* For osp() 5-min log records */
      ++pi->n_pkts;  

      if (!live_source) {  /* Reading a trace file */
         if (pi->nrecords % 10000 == 0) {  /* Indicate progress */
            printf(minj == 0 ? "." : ":");  fflush(stdout);
            }
 // if (pi->nrecords == 200) stop_meter(3);  //03
         if (!next_dag_record(pi)) {  /* EOF */
            ntm_semaphore_up("dm", &merge_sync_empty);
               /* Block until non_live_source decides what to do */
            ntm_semaphore_down("dm", &merge_sync_full);
            }
         else if (last_t_sec > save_lts) {
            starting = save_lts == 0;
            /* last_t_sec updated in handle_pkt(), from t_pkt_monitor() */
            if (save_lts != 0) {
               t_delta = last_t_sec - save_lts;
               if (t_delta != 1) printf("%d", t_delta);
               }
            save_lts = last_t_sec;
            if (starting)  /* Just getting started */
               ntm_semaphore_down("dm", &merge_sync_full);
            else if ((trace_count -= t_delta) <= 0) {
               ntm_semaphore_up("dm", &merge_sync_empty);
                  /* Block until non_live_source decides what to do */
               ntm_semaphore_down("dm", &merge_sync_full);
	       }
            }
         }
      else next_dag_record(pi);

# if MULTI
      if (pi->n_pkts % 1000 == 0) {
         times(&tbuf);
         dag_merge_proct = tbuf.tms_utime+tbuf.tms_stime;
         total_thread_proct += (dag_merge_proct - last_dag_merge_proct);
#  if LOG_THREAD_PROCTIMES
         thread_proctime[this_tn] += (dag_merge_proct - last_dag_merge_proct);
#  endif   
         last_dag_merge_proct = dag_merge_proct;
         }
# endif
      }
   }

int next_trace_record(struct interface_info *pi)
{

   int rl, bl, left_ib;

   if (pi->nblocks != 0) {  /* Current record is OK */
      if (pi->dag_type != TT_EXT) rl = 64;
      else  rl = ntohs(pi->dbp->d.ext.rlen);
      pi->dbp = (struct dag_rec *)( ((Bit8 *)pi->dbp) + rl );
      pi->fbx += rl;
      bl = pi->fbr - pi->fbx;
      if (bl > 16) {  /* Enough for Dag ERF header */
         if (pi->dag_type != TT_EXT) rl = 64;
         else  rl = ntohs(pi->dbp->d.ext.rlen);
         if (bl >= rl) {  /* Enough for whole record */
            if (start_us_needed) {
               meter_start_time = pi->dbp->ts;
               start_uptime_clock();  /*Sets meter_start_us */
               start_us_needed = 0;
               } 
#if DEBUG_TF_READ > 1
            printf("%8d %10d.%06d: %02x-%02x %u %u %u\n",
               pi->ipackets, DAGT_S(pi->dbp->ts), DAGT_US(pi->dbp->ts),
	       pi->dbp->d.ext.type, pi->dbp->d.ext.flags,
	       rl, ntohs(pi->dbp->d.ext.lctr), ntohs(pi->dbp->d.ext.wlen) );
	    fflush(stdout);
#endif
            ++pi->ipackets;  /* For global statistics */
            return 1;
            }
         }
      }

   left_ib = pi->fbr - pi->fbx;
   memcpy(pi->fbuf, &pi->fbuf[pi->fbx], left_ib);
#if HAVE_LIBZ
   if ((pi->fbr = gzread(pi->gfp, &pi->fbuf[left_ib], DF_BLK_SZ-left_ib))
         == 0) {
      gzclose(pi->gfp);
      pi->gfp = NULL;
#else
   if ((pi->fbr = read(pi->t_fd, &pi->fbuf[left_ib], DF_BLK_SZ-left_ib))
         == 0) {
      close(pi->t_fd);
      pi->t_fd = -1;
#endif
      return 0;  /* End of file */
      }
   ++pi->nblocks;
   pi->fbr += left_ib;
   pi->fbx = 0;
   pi->dbp = (struct dag_rec *)pi->fbuf;
#if DEBUG_TF_READ > 1
   printf("\n%8d %10d.%06d: %02x-%02x %u %u %u\n",
      pi->ipackets, DAGT_S(pi->dbp->ts), DAGT_US(pi->dbp->ts),
      pi->dbp->d.ext.type, pi->dbp->d.ext.flags,
      ntohs(pi->dbp->d.ext.rlen),
      ntohs(pi->dbp->d.ext.lctr), ntohs(pi->dbp->d.ext.wlen) );
   fflush(stdout);
#endif
   ++pi->ipackets;  /* For global statistics */
   return 1;
   }

int next_dag_record(struct interface_info *pi)
{
   int rl;
   struct timespec rqt; //28

   if (!live_source) {
//     if (pi->nrecords >= 200) stop_meter(99);  // //
      ++pi->ipackets;  /* For global statistics */
      return next_trace_record(pi);
      }
   else {
      if (pi->r_pkts == 0) {
         for (;;) {
            ntm_semaphore_up("ndr", &pi->db_empty);
               /* Wait while run_dag_read gets the next block */
            ntm_semaphore_down("gnb", &pi->db_ready);
	    if (pi->r_pkts != 0) break;
            rqt.tv_sec = 0;  rqt.tv_nsec = 1200000;  /* 1.2 ms */
	    /* CAUTION: nanosleep busy-waits for times < 1 ms */
            nanosleep(&rqt, NULL);
            }
         --pi->r_pkts;  /* Return first pkt in buffer */
         }
      else {
         if (pi->dag_type != TT_EXT) rl = 64;
         else  rl = ntohs(pi->dbp->d.ext.rlen);
         pi->dbp = (struct dag_rec *)( ((Bit8 *)pi->dbp) + rl );
         --pi->r_pkts;  /* pkts remaining in buffer */
         }
      }
   ++pi->ipackets;  /* For global statistics */
   return 1;
   }

void *run_dag_read(void *arg)
{
   struct interface_info *pi = (struct interface_info *)arg;
   unsigned s_top, top;
   struct dag_rec *dbp;
   int rl, nip, nib;
#if NO_MERGE_THREAD 
   struct pkt *pp;
#endif

   Bit32 dag_read_proct, last_dag_read_proct = 0;
   struct tms tbuf;
#if LOG_THREAD_PROCTIMES
   int this_tn = assign_thr_log_nbr();
   sprintf(thread_name[this_tn], "dag_read %d", pi->nbr);
   thread_proctime_org[this_tn] = thread_proctime[this_tn] = 0;
#endif   

   s_top = 0;
   for (;;) {
#if !NO_MERGE_THREAD 
// printf("if %d, r_d_r() down empty\n", pi->nbr);  // //
      ntm_semaphore_down("rdr", &pi->db_empty);
#endif

#if DAG_DELAY_READ
         timeout.tv_sec = 0;  timeout.tv_usec = select_us;
         select(FD_SETSIZE, 0, 0, 0, &timeout);
#endif

      errno = 0;  /* System call error variable */
      pi->bottom = s_top;
      top = dag_offset(pi->fd, &pi->bottom, 0);
// printf("i/f %d, dag_offset: s_top=%u, bottom=%u, top=%u\n",
//   pi->nbr, s_top, pi->bottom, top); //02
//  fflush(stdout);
      dbp = (struct dag_rec *)(pi->dbuf + pi->bottom);
      s_top = pi->bottom;  /* dag_offset may change bottom,
                              top stays correct relative to bottom */
      nip = nib = 0;
      for (;;) {
         if (pi->dag_type != TT_EXT) rl = 64;
         else {
            rl = ntohs(dbp->d.ext.rlen);
            if (dbp->d.ext.lctr) {
               pi->idrops += ntohs(dbp->d.ext.lctr);
               if (dbp->d.ext.lctr == 0xFFFF) {
                  ++pi->n_stuck_lctrs;
                  log_msg(LOG_INFO, 0,
                     "i/f %d lctr=0xFFFF, can't count lost packets", pi->nbr);
                  }
               }
            }

         if (nib + rl > sizeof(struct dag_rec)*DAG_BUF_SZ) {
               /* Won't fit in in_buf */
            break;
            } 

         if (s_top + rl == top) {  /* No more data */
            break;  /* Leave one record in buffer <<<<<
               On Linux dag_offset suspends until it gets a record,
               but on FreeBSD it seems to loop in thread-handler routines.
               Leaving a record in the buffer means that dag_offset
               always returns at least one record; next_dag_record()
               can nanosleep() when it gets 0 records, i.e. no busy-wait */
            } 

         if (s_top + rl > top) {  /* Partial record (shouldn't happen) */
            log_msg(LOG_INFO, 0,
               "i/f %d, got partial rec: %d B, rl=%d, %d pkts",
                pi->nbr, rl,nib, nip);
            break;
            }
         dbp = (struct dag_rec *)( ((Bit8 *)dbp) + rl );
         s_top += rl;
#if !NO_MERGE_THREAD 
         nib += rl;  ++nip;
#else  /* Not mergeing .. */
//IP++         ++pi->ipackets;  /* For global statistics */
         ++pi->nrecords;  /* For osp() 5-min log records */
         ++pi->n_pkts;  
         pp = pkt_from_dag_record(dbp, pi);
         if (pp != NULL) {  /* We have a packet */
# if PKT_DEBUG
   if (pp->pkt_state != 1) {
      printf("dag_merge(): not got, pp=%x\n", pp);  fflush(stdout);
      quack(501);
      }
# endif
            last_ts = dbp->ts;  /* Used by uptime() routines */
   //?   printf(".");  fflush(stdout);
            t_pkt_monitor(pp);
            }
#endif
         }

#if !NO_MERGE_THREAD 
      pi->dbp = (struct dag_rec *)(pi->dbuf + pi->bottom);
      pi->r_pkts = nip;
      pi->card_ts = pi->dbp->ts;
#else
      pi->card_ts = last_ts;
#endif
      ++pi->nblocks;
// if (nip != 0)  //02
//    printf("if %d, r_d_r() %d pkts, bottom=%u, s_top=%u, top=%u\n",
//       pi->nbr, pi->r_pkts, pi->bottom, s_top, top); //02 
#if !NO_MERGE_THREAD 
      ntm_semaphore_up("rdr", &pi->db_ready);
#endif 
      times(&tbuf);
#if MULTI
      dag_read_proct = tbuf.tms_utime+tbuf.tms_stime;
      total_thread_proct += (dag_read_proct - last_dag_read_proct);
# if LOG_THREAD_PROCTIMES
      thread_proctime[this_tn] += (dag_read_proct - last_dag_read_proct);
# endif   
      last_dag_read_proct = dag_read_proct;
#endif
      }
   }

void init_live_sources(void)
{
   int j;
   struct interface_info *pi;
   for (j = 0; j != n_interfaces; ++j) {
      pi = pci[j];
#if !NO_MATCH_THREAD
      while (pi->nblocks == 0) next_dag_record(pi);
#else
      next_dag_record(pi);
      {int k; for (k = 200; k != 0; --k) {
	  if (pi->nblocks == 0) printf(".");
	  else break;
	}
	fflush(stdout); }
#endif
      pi->running = 1;
      if (pi->dbp->d.ext.type == 0 && pi->dag_type == TT_EXT)
         log_msg(LOG_ERR, 1,
            "Trace file %s has LEGACY records; use -g to specify Dag type!",
            pi->name);
      }
   meter_start_time = pci[0]->card_ts;  /* Set to min Dag timestamp */
   for (j = 1; j != n_interfaces; ++j) {
      if (pci[j]->card_ts <= meter_start_time)
         meter_start_time = pci[j]->card_ts;
      }
   start_uptime_clock();

   log_msg(LOG_INFO, 0, "init_live_sources(): first blocks read");
   fflush(stdout);
   }

int open_dag_direct(struct interface_info *pi)
{
   int ifd, flags;
   char options[50], *vopt;

   if (!live_source) {
#if HAVE_LIBZ
      if ((pi->gfp = gzopen(pi->name,"r")) == NULL) {
#else
      if ((pi->t_fd = open(pi->name, O_RDONLY)) < 0) {
#endif
         log_msg(LOG_ERR, 0,
            "i/f open(%s) failed: %s\n", pi->name, strerror(errno));
         return 0;  /* Fail */
         }
      log_msg(LOG_WARNING, 0, "Trace file %s opened", pi->name);
      }
   else {  /* Live source */
#if DAG_NEW_API
      if (pi->running) {
         if (dag_stop(pi->fd) < 0)
            log_msg(LOG_ERR, 0, "dag_stop %s: %s\n", pi->name, strerror(errno));
         if (dag_start(pi->fd) < 0)
            log_msg(LOG_ERR, 1, "dag_start %s: %s\n", pi->name, strerror(errno));
         }
      else {
         if ((ifd = dag_open(pi->name)) < 0)
            log_msg(LOG_ERR, 1, "dag_open %s: %s\n", pi->name, strerror(errno));

	 vopt = pi->dag_varlen ? "varlen" : "fixed";
// //         sprintf(options, "slen=%d %s", pi->dag_slen, vopt);
         sprintf(options, "%s slen=%d", vopt, pi->dag_slen);
         log_msg(LOG_WARNING, 0, "Starting i/f %d, %s: options='%s'",
            pi->nbr, pi->name, options);
         if (dag_configure(ifd, options) < 0)
            log_msg(LOG_ERR, 1, "dag_configure %s: %s\n", pi->name, strerror(errno));

         if ((pi->dbuf = dag_mmap(ifd)) == MAP_FAILED)
            log_msg(LOG_ERR, 1, "dag_mmap %s: %s\n", pi->name, strerror(errno));

         if (dag_start(ifd) < 0)
            log_msg(LOG_ERR, 1, "dag_start %s: %s\n", pi->name, strerror(errno));
         }
#else
      if (pi->fd != 0) {
         if (close(pi->fd) < 0) {
            log_msg(LOG_ERR, 0,
               "i/f: close(%s) failed: %s\n", pi->name, strerror(errno));
            return 0;  /* Fail */
            }
         pi->fd = 0;
         }
      if ((ifd = open(pi->name, O_RDONLY)) < 0) {
         log_msg(LOG_ERR, 0,
            "i/f: open(%s) failed: %s\n", pi->name, strerror(errno));
         return 0;  /* Fail */
         }

      if ((flags = fcntl(ifd, F_GETFL, 0)) < 0) {
         log_msg(LOG_ERR, 0, "iif: getfl(%s): fcntl get failed\n", pi->name);
         return 0;  /* Fail */
         }
# if MULTI
      flags &= !O_NONBLOCK;  /* Blocking reads for threaded meter */
# else
      flags |= O_NONBLOCK;  /* Non-blocking reads for single-thread meter */
# endif
      if (fcntl(ifd, F_SETFL, flags) < 0) {
         log_msg(LOG_ERR, 0, "iif: nonblck(%s): fcntl set failed\n", pi->name);
         return 0;  /* Fail */
         }
#endif
      }

   pi->fd = ifd;
   return 1;  /* OK */
   }

#if DAG_NEW_API
void dag_close_all(void)
{
   int j;
   for (j = 0; j != n_interfaces; ++j) {
      if (dag_stop(pci[j]->fd) < 0)
         log_msg(LOG_ERR, 0, "dag_stop %s: %s\n", pci[j]->name, strerror(errno));
      if (dag_close(pci[j]->fd) < 0)
         log_msg(LOG_ERR, 0, "dag_close %s: %s\n", pci[j]->name, strerror(errno));
      }
   }
#   endif

int init_interface(struct interface_info *pi)  /* Dag direct */
{
   if (strncmp(pi->name, "/dev/", 5) != 0) {
      init_tracefile_read(pi->name, "Dag");
      if ((pi->fbuf = malloc(DF_BLK_SZ)) == NULL) {
         log_msg(LOG_ERR, 99,
            "Not enough memory for file %s buffer!", pi->name);
         }
      }

   pi->last_errno = 0;
   if (!open_dag_direct(pi)) return 0;

#if MULTI
   if (live_source) {
      ntm_semaphore_init("dag_in_ready",pi->nbr, &pi->db_ready);
      semaphore_decrement(&pi->db_ready);  /* Thread blocked */
      ntm_semaphore_init("dag_in_empty",pi->nbr, &pi->db_empty);
      semaphore_decrement(&pi->db_empty);
      if (gprof_pthread_create(&pi->dag_thread, NULL, run_dag_read, pi)) {
         log_msg(LOG_ERR, 1, "Error creating thread for i/f %d", pi->nbr);
         }
      }
   /* Non-live source: dag_merge() does file reads in next_trace_record() */
#endif

   return 1;  /* OK */
   }

unsigned int pkt_counts(int reset)
{
   int j;
   struct interface_info *pi;

   pkts = drops = 0L;  /* Get total packets seen and dropped */
   for (j = 0; j != n_interfaces; ++j) {
      pi = pci[j];
      pkts += pi->ipackets;  drops += pi->idrops;
      }
   if (reset) {  /* Was doing this before setting pkts  19 Nov 03 */
      npackets_org = pkts;  lostpackets_org = drops;
      }

#if 0
   printf("pkt_counts(b): pkts=%u, drops=%u, npkts=%u, lost=%u\n",
      pkts, drops, npackets, lostpackets);  //IP++
#endif
   npackets = pkts - npackets_org;
   lostpackets = drops - lostpackets_org;
   return 1;
   } 

/* ===== End of Dag direct interface code ===== */

#else  /* !NF_CISCO_DATA && !CR_DATA && !LFAP_METER 
             && !ADSL_DATA && !DAG_DIRECT */

/* ===== Interface code using libpcap to get packet headers ===== */

#define PCAPWAITMS  50  /* ms to wait on packet-header-block reads */

struct ether_hdr null_e_hdr = {  /* For PPP callback */
   0,0,0,0,0,0, 0,0,0,0,0,0, 0
   };

/* ----- Following fddi code is from tcpdump's print-fddi.c ----- */

#ifdef __GNUC__  /* These defines from interface.h .. */
#define inline __inline
#ifndef __dead
#define __dead volatile
#endif
#else
#define inline
#define __dead
#endif

#include <fddi.h>

/*
 * Some FDDI interfaces use bit-swapped addresses.
 */
#if defined(ultrix) || defined(__alpha)
int	fddi_bitswap = 0;
#else
int	fddi_bitswap = 1;
#endif

/*
 * FDDI support for tcpdump, by Jeffrey Mogul [DECWRL], June 1992
 *
 * Based in part on code by Van Jacobson, which bears this note:
 *
 * NOTE:  This is a very preliminary hack for FDDI support.
 * There are all sorts of wired in constants & nothing (yet)
 * to print SMT packets as anything other than hex dumps.
 * Most of the necessary changes are waiting on my redoing
 * the "header" that a kernel fddi driver supplies to bpf:  I
 * want it to look like one byte of 'direction' (0 or 1
 * depending on whether the packet was inbound or outbound),
 * two bytes of system/driver dependent data (anything an
 * implementor thinks would be useful to filter on and/or
 * save per-packet, then the real 21-byte FDDI header.
 * Steve McCanne & I have also talked about adding the
 * 'direction' byte to all bpf headers (e.g., in the two
 * bytes of padding on an ethernet header).  It's not clear
 * we could do this in a backwards compatible way & we hate
 * the idea of an incompatible bpf change.  Discussions are
 * proceeding.
 * * Also, to really support FDDI (and better support 802.2
 * over ethernet) we really need to re-think the rather simple
 * minded assumptions about fixed length & fixed format link
 * level headers made in gencode.c.  One day...
 *
 *  - vj
 */

#define FDDI_HDRLEN (sizeof(struct fddi_header))

static u_char fddi_bit_swap[] = {
	0x00, 0x80, 0x40, 0xc0, 0x20, 0xa0, 0x60, 0xe0,
	0x10, 0x90, 0x50, 0xd0, 0x30, 0xb0, 0x70, 0xf0,
	0x08, 0x88, 0x48, 0xc8, 0x28, 0xa8, 0x68, 0xe8,
	0x18, 0x98, 0x58, 0xd8, 0x38, 0xb8, 0x78, 0xf8,
	0x04, 0x84, 0x44, 0xc4, 0x24, 0xa4, 0x64, 0xe4,
	0x14, 0x94, 0x54, 0xd4, 0x34, 0xb4, 0x74, 0xf4,
	0x0c, 0x8c, 0x4c, 0xcc, 0x2c, 0xac, 0x6c, 0xec,
	0x1c, 0x9c, 0x5c, 0xdc, 0x3c, 0xbc, 0x7c, 0xfc,
	0x02, 0x82, 0x42, 0xc2, 0x22, 0xa2, 0x62, 0xe2,
	0x12, 0x92, 0x52, 0xd2, 0x32, 0xb2, 0x72, 0xf2,
	0x0a, 0x8a, 0x4a, 0xca, 0x2a, 0xaa, 0x6a, 0xea,
	0x1a, 0x9a, 0x5a, 0xda, 0x3a, 0xba, 0x7a, 0xfa,
	0x06, 0x86, 0x46, 0xc6, 0x26, 0xa6, 0x66, 0xe6,
	0x16, 0x96, 0x56, 0xd6, 0x36, 0xb6, 0x76, 0xf6,
	0x0e, 0x8e, 0x4e, 0xce, 0x2e, 0xae, 0x6e, 0xee,
	0x1e, 0x9e, 0x5e, 0xde, 0x3e, 0xbe, 0x7e, 0xfe,
	0x01, 0x81, 0x41, 0xc1, 0x21, 0xa1, 0x61, 0xe1,
	0x11, 0x91, 0x51, 0xd1, 0x31, 0xb1, 0x71, 0xf1,
	0x09, 0x89, 0x49, 0xc9, 0x29, 0xa9, 0x69, 0xe9,
	0x19, 0x99, 0x59, 0xd9, 0x39, 0xb9, 0x79, 0xf9,
	0x05, 0x85, 0x45, 0xc5, 0x25, 0xa5, 0x65, 0xe5,
	0x15, 0x95, 0x55, 0xd5, 0x35, 0xb5, 0x75, 0xf5,
	0x0d, 0x8d, 0x4d, 0xcd, 0x2d, 0xad, 0x6d, 0xed,
	0x1d, 0x9d, 0x5d, 0xdd, 0x3d, 0xbd, 0x7d, 0xfd,
	0x03, 0x83, 0x43, 0xc3, 0x23, 0xa3, 0x63, 0xe3,
	0x13, 0x93, 0x53, 0xd3, 0x33, 0xb3, 0x73, 0xf3,
	0x0b, 0x8b, 0x4b, 0xcb, 0x2b, 0xab, 0x6b, 0xeb,
	0x1b, 0x9b, 0x5b, 0xdb, 0x3b, 0xbb, 0x7b, 0xfb,
	0x07, 0x87, 0x47, 0xc7, 0x27, 0xa7, 0x67, 0xe7,
	0x17, 0x97, 0x57, 0xd7, 0x37, 0xb7, 0x77, 0xf7,
	0x0f, 0x8f, 0x4f, 0xcf, 0x2f, 0xaf, 0x6f, 0xef,
	0x1f, 0x9f, 0x5f, 0xdf, 0x3f, 0xbf, 0x7f, 0xff,
};

/* Extract src, dst addresses */
static inline void extract_fddi_addrs(
   const struct fddi_header *fddip, 
   unsigned char *fsrc, unsigned char *fdst)
{
	register int i;

	if (fddi_bitswap) {
		/*
		 * bit-swap the fddi addresses (isn't the IEEE standards
		 * process wonderful!) then convert them to names.
		 */
		for (i = 0; i < 6; ++i)
			fdst[i] = fddi_bit_swap[fddip->fddi_dhost[i]];
		for (i = 0; i < 6; ++i)
			fsrc[i] = fddi_bit_swap[fddip->fddi_shost[i]];
	}
	else {
		memcpy(fdst, fddip->fddi_dhost, 6);
	        memcpy(fsrc, fddip->fddi_shost, 6);
	}
}

/* ----- End of fddi code from tcpdump's print-fddi.c ----- */

#define get_short(a)  (a[0] << 8 | a[1])

void fddi_callback(struct interface_info *user,
   struct pcap_pkthdr *h, u_char *p)
{
   const struct fddi_header *fp = (struct fddi_header *)p;
   int caplen = h->caplen;
   struct ether_hdr ehdr;
#if COPY_STRUCTS
   struct llc llc;
#else
   struct llc *llc;
#endif
   struct pkt *p_p;
   unsigned int ether_type, lsap;

   ++user->ipackets;  /* Since startup */
   ++user->n_pkts_read;  /* This pcap_dispatch()/loop() */

   if (--user->sample_count == 0) {  /* Process only 1 pkt per SampleRate */
      user->sample_count = user->SampleRate;

      if (caplen < FDDI_HDRLEN) return;  /* Too short! */

      if ((p_p = get_pkt()) == NULL) {
         ++user->idrops;
         return;  /* No free pkt s, drop the packet */
         }

      /* Get the FDDI addresses into a canonical form */
      if (adj_reqd)  /* Don't do this unless we have to! */
         extract_fddi_addrs(fp, ehdr.source, ehdr.dest);

      if ((fp->fddi_fc & FDDIFC_CLFF) == FDDIFC_LLC_ASYNC) {
         caplen -= FDDI_HDRLEN;
         if (caplen < sizeof(struct llc)) return;  /* Too short! */
         p += FDDI_HDRLEN;
#if COPY_STRUCTS  /* tcpdump does this; don't know why */
         memcpy((char *)&llc, (char *)p, sizeof(llc));
         lsap = llc.dsap << 8 | llc.ssap;
         if (lsap == 0xAAAA) {  /* SNAP packet */
            ether_type = get_short(llc.ctl.snap_ether.snap_ethertype);
            p += sizeof(struct llc);
            }
         else ether_type = 0;  /* Other 802.2 packet */
#else  /* This works, at least for Solaris 2.4 */
         llc = (struct llc *)p;
         lsap = llc->dsap << 8 | llc->ssap;
         if (lsap == 0xAAAA) {  /* SNAP packet */
            ether_type = get_short(llc->ctl.snap_ether.snap_ethertype);
            p += sizeof(struct llc);
            }
         else ether_type = 0;  /* Other 802.2 packet */
#endif
         p_p->p_len = h->len;  /* Bug fix from Dylan Hall, 31 May 00 */
         p_p->arrival_time = microseconds(h->ts);
         if (start_us_needed) {
            meter_start_us = p_p->arrival_time;
            start_us_needed = 0;
            } 
        p_p->datagram_len = p_p->p_len - sizeof(struct llc);
        if (handle_pkt(p_p, ether_type,lsap, (unsigned char *)&ehdr,
               p, caplen - sizeof(struct llc))) {
            p_p->adj_type = user->adjtype;
            p_p->if_nbr = user->nbr;
#if MULTI
            if (user->p_head == NULL)  
               user->p_head = user->p_tail = p_p; 
            else { 
               user->p_tail->next_pp = p_p;  user->p_tail = p_p; 
               } 
            ++user->p_qlen; 
/*            printf("   p_head=%x, p_tail=%x\n", user->p_head, user->p_tail);
              fflush(stdout);  */
#else
            process_pkt(p_p);
#endif
	    }
         else free_pkt(p_p);  /* Didn't want it */
         }
      }
   }

void ether_callback(struct interface_info *user,
   struct pcap_pkthdr *h, u_char *p)
{
   struct ether_hdr *ethp;
   struct llc *llcp;
   struct pkt *p_p;
   int ether_type,lsap, len;

   ++user->ipackets;  /* Since startup */
   ++user->n_pkts_read;  /* This pcap_dispatch()/loop() */

   if (--user->sample_count == 0) {  /* Process only 1 pkt per SampleRate */
      user->sample_count = user->SampleRate;

      if ((p_p = get_pkt()) == NULL) {
         ++user->idrops;
         return;  /* No free pkts, drop the packet */
         }

      p_p->datagram_len = p_p->p_len = h->len;  /* On-the-wire length */
      p_p->arrival_time = microseconds(h->ts);
      if (start_us_needed) {
         meter_start_us = p_p->arrival_time;
         start_us_needed = 0;
         }

      len = h->caplen;
      if (user->adjtype == AT_LINUX_COOKED) {
         /* Ignore Linux info in first two bytes */
         p += 2;  len -= 2;  p_p->datagram_len -= 2;
         }

      ethp = (struct ether_hdr *)p;
      ether_type = ntohs(ethp->type);
#if V6_DEBUG
      printf("ether_callback(): ether_type=%04x\n", ether_type);
#endif
      p += sizeof(struct ether_hdr);  len -= sizeof(struct ether_hdr);
      p_p->datagram_len -= sizeof(struct ether_hdr);
      if (ether_type <= 1500) {  /* 802.3 packet */
         llcp = (struct llc *)p;
         lsap = ntohs(*(Bit16 *)&llcp->dsap);
         if (lsap == 0xAAAA) {  /* SNAP packet */
            ether_type = ntohs(*(Bit16 *)&llcp->ctl.snap_ether.snap_ethertype);
            p += sizeof(struct llc);  len -= sizeof(struct llc);
            p_p->datagram_len -= sizeof(struct llc);
            }
         else ether_type = 0;  /* Other 802.2 packet */
         }
      else lsap = 0;  /* Blue book packet */

#if 0  //T
   printf("e_cb():%d  %.6f %d\n", user->n_pkts_read,  //T
      p_p->arrival_time/1000000.0, p_p->p_len);
   fflush(stdout);
#endif  //T

      if (handle_pkt(p_p, ether_type,lsap,(Bit8 *)ethp, p, len)) {
         p_p->adj_type = user->adjtype;
         p_p->if_nbr = user->nbr;
#if MULTI
         if (user->p_head == NULL)  
            user->p_head = user->p_tail = p_p; 
         else { 
            user->p_tail->next_pp = p_p;  user->p_tail = p_p; 
            } 
         ++user->p_qlen; 
/*       printf("   p_head=%x, p_tail=%x\n", user->p_head, user->p_tail);
            fflush(stdout);  /**/
#else
         process_pkt(p_p);
#endif
         }
      else {
/*       printf("e_cb(): handle_pkt() failed\n"); fflush(stdout);  /**/
         free_pkt(p_p);  
         }
      }
   }

void ppp_callback(struct interface_info *user,
   struct pcap_pkthdr *h, u_char *p)
{
   struct ether_hdr *ethp;
   struct llc *llcp;
   struct pkt *p_p;
   unsigned int ether_type, lsap;
   int len, j;

   ++user->ipackets;  /* Since startup */
   ++user->n_pkts_read;  /* This pcap_dispatch()/loop() */

   if (--user->sample_count == 0) {  /* Process only 1 pkt per SampleRate */
      user->sample_count = user->SampleRate;

      if ((p_p = get_pkt()) == NULL) {
         ++user->idrops;
         return;  /* No free pkt s, drop the packet */
         }

      p_p->datagram_len = p_p->p_len = h->len;  /* On-the-wire length */
      p_p->arrival_time = microseconds(h->ts);
      if (start_us_needed) {
         meter_start_us = p_p->arrival_time;
         start_us_needed = 0;
         }
      if (handle_pkt(p_p, 0x0800,0,  /* Assume it's an IP packet */
            (unsigned char *)&null_e_hdr, p, h->caplen)) {
         p_p->adj_type = user->adjtype;
         p_p->if_nbr = user->nbr;
#if MULTI
         if (user->p_head == NULL)  
            user->p_head = user->p_tail = p_p; 
         else { 
            user->p_tail->next_pp = p_p;  user->p_tail = p_p; 
            } 
         ++user->p_qlen; 
/*         printf("   p_head=%x, p_tail=%x\n", user->p_head, user->p_tail);
           fflush(stdout);  */
#else
         process_pkt(p_p);
#endif
         }
      else free_pkt(p_p);  /* Didn't want it */
      }
   }

#if MULTI_BUF_SZ == 0
#define PCAP_READ_COUNT  5  /* For testing on quiet interfaces */
#else
#define PCAP_READ_COUNT  (N_PME_BUFS+3)
#endif

int interface_read(struct interface_info *pi)  /* libpcap */
{
   pi->n_pkts_read = 0;
   if (live_source)  /* dispatch() returns after timeout */
//???      pcap_dispatch(pi->pd, PCAP_READ_COUNT, pi->callback, (u_char *)pi);
      pcap_loop(pi->pd, PCAP_READ_COUNT, pi->callback, (u_char *)pi);
   else {  /* Non-live  (loop reads spec number of records) */
      pcap_loop(pi->pd, N_PME_BUFS/3+1, pi->callback, (u_char *)pi);
      if (pi->n_pkts_read == 0) {  /* EOF on trace file */
         pcap_close(pi->pd);  pi->pd = NULL;
         }
      }
   return pi->n_pkts_read != 0;
   }

int init_interface(struct interface_info *pi)  /* libpcap */
{
   char *interface, errbuf[PCAP_ERRBUF_SIZE];
   pcap_t *pd;
   int type, bufsz, szlen;
   struct stat sb;
   int nlen, using_fifo, npr;

   if (pi->name[0] != '\0' && stat(pi->name, &sb) == 0) {  /* It's a file */
      using_fifo = 0;
#if HAVE_LIBZ
      nlen = strlen(pi->name);
      if (nlen > 3 && strcmp(pi->name + nlen-3, ".gz") == 0) {
         /* libpcap can't read gzipped files.  Code to do this (by
            unzipping the file to a fifo and having libpcap read it
            from there) was derived from CoralReef 3.7, with grateful
            thanks to Ken Keys.
            Read the copyright notices in the Coralreef source! */
         char fifoname[PATH_MAX];
         char *dir;
         pid_t pid;
         static int tmpcount = 0;  /* May need more than one fifo */
         dir = getenv("TMPDIR");
         sprintf(fifoname, "%.*s/ntm.%d.%d", sizeof(fifoname) - 30,
             dir ? dir : "/tmp", tmpcount++, getpid());
         if (!(pi->gfp = gzopen(pi->name, "rb"))) {
             printf("init_interface(%s): gzopen %s: %s\n",
                pi->name, pi->name, strerror(errno));
            goto error;
            }
         if (mkfifo(fifoname, S_IRWXU) != 0) {
             printf("init_interface(%s): mkfifo %s: %s\n",
                pi->name, fifoname, strerror(errno));
            goto error;
            }
         using_fifo = 1;
         /* printf("gzipped file %s: mkfifo %s\n", pi->name, fifoname); */

         if ((pid = fork()) < 0) {
            /* fork: error */
            printf("init_interface(%s): fork: %s\n",
                pi->name, strerror(errno));
            error:
                if (pi->gfp) gzclose(pi->gfp);
                unlink(fifoname);
                return 0;  /* Fail */
            }
         else if (pid == 0) {
            /* fork: child */
            ssize_t nread, nwritten, offset;
            int fifo, exitval = 1;
            char buf[8192];
            if ((fifo = open(fifoname, O_WRONLY)) < 0) {
                printf("init_interface(%s): open %s: %s\n",
                    pi->name, fifoname, strerror(errno));
                unlink(fifoname);
                goto childexit;
                }
            while ((nread = gzread(pi->gfp, buf, sizeof(buf))) > 0) {
               offset = 0;
               while (nread > 0) {
                  nwritten = write(fifo, buf + offset, nread);
                  if (nwritten < 0) goto childexit;
                  offset += nwritten;
                  nread -= nwritten;
                  }
               }
            if (nread == 0) exitval = 0;
         childexit:
            gzclose(pi->gfp);  close(fifo);
            exit(exitval);
            }

         gzclose(pi->gfp);
         strcpy(pi->name, fifoname);
#endif  /* HAVE_LIBZ */
         }

      if ((pd = pcap_open_offline(pi->name, errbuf)) != NULL) {
         if (using_fifo) unlink(pi->name);
         init_tracefile_read(pi->name, "libpcap");
         }
      else {
         printf("pcap_open_offline(%s) failed: %s\n", pi->name,errbuf);
         return 0;  /* Fail */
         }
      }

   else {  /* See whether it's an interface */
      if (pi->name[0] == '\0') {
         if (!(interface = pcap_lookupdev(errbuf))) {
            log_msg(LOG_ERR, 0, "pcap_lookupdevice(): %s\n",errbuf);
            return 0;  /* Fail */
            }
         else strcpy(pi->name,interface);
         }

      if ((pd = pcap_open_live(pi->name, SNAPSIZE, 1,
            PCAPWAITMS, errbuf)) != NULL) {  /* It's a pcap device */
#if LINUX  /* Suggested by Joerg Schumacher */
         bufsz = 4*1024*1024;  /* Assume we'll get max OS allows */
         setsockopt(pd->fd, SOL_SOCKET, SO_RCVBUF, &bufsz, sizeof(bufsz));
         bufsz = 0;  szlen = sizeof(bufsz);
         getsockopt(pd->fd, SOL_SOCKET, SO_RCVBUF, &bufsz, (socklen_t *)&szlen);
         printf("i/f %s, Linux pcap buffer size = %d\n", pi->name, bufsz);
#elif FREEBSD
         bufsz = 0;
         ioctl(pd->fd, BIOCGBLEN, &bufsz);
         printf("i/f %s, BPF pcap buffer size = %d\n", pi->name, bufsz);
#endif
         }
      else {
         log_msg(LOG_ERR, 0, "pcap_open_live(%s) failed: %s\n", pi->name,errbuf);
         return 0;  /* Fail */
         }
      }

   pi->pd = pd;  pi->fd = pd->fd;
 
   switch (type = pcap_datalink(pd)) {
   case DLT_EN10MB:
   case DLT_IEEE802:
#if CYGWIN32
   case DLT_EN100MB:
#endif
      pi->adjtype = AT_ETHERNET;
      pi->callback = (pcap_handler)ether_callback;
      break;
   case DLT_LINUX_SLL:  /* For Linux ATM at RUS */
      pi->adjtype = AT_LINUX_COOKED;
      pi->callback = (pcap_handler)ether_callback;
      break;
   case DLT_ATM_CLIP:  /* For Priscilla Francielle,
         don't know exactly what's in buffer, try ethernet first */
      pi->adjtype = AT_ATM;
      pi->callback = (pcap_handler)ether_callback;
      break;
#if CYGWIN32
   case DLT_PPP_WIN32:  /* WinDump dummies up a MAC header (!) */
      pi->adjtype = AT_PPP;
      pi->callback = (pcap_handler)ether_callback;
      break;
#endif
   case DLT_RAW:
   case DLT_SLIP_BSDOS:
   case DLT_PPP_BSDOS:
      pi->adjtype = AT_PPP;
      pi->callback = (pcap_handler)ppp_callback;
      break;
   case DLT_FDDI:
      pi->adjtype = AT_FDDI;
      pi->callback = (pcap_handler)fddi_callback;
      break;
   default:
      log_msg(LOG_ERR, 0, "pcap bad link type 0x%x!\n", type);
      pcap_close(pd);
      return 0;  /* Fail */
      }
   pi->n_pkts_read = 0;
   do {
      pcap_loop(pi->pd, 1, pi->callback, (u_char *)pi);
#if DEBUG_TF_READ
      printf("init_if(1): PME_BUF_RECS=%d, n_pkts_read=%d\n", 
         PME_BUF_RECS, pi->n_pkts_read);  fflush(stdout);
#endif
      } while (pi->n_pkts_read == 0);

#if MULTI
//?   meter_start_time.tv_sec = meter_start_us/1000000.0;
//?   meter_start_time.tv_usec = meter_start_us -
//?      meter_start_time.tv_sec*1000000.0;
   /* LIBPCAP (and DAG cards) use last_t_us, double rather than
      ts_type.  last_t_us is set by pkt_monitor() - 
         we no longer use meter_start_time   Nevil, Sat 5 Aug 05 */

   ntm_semaphore_init("pcap_in_ready",pi->nbr, &pi->ib_ready);
   semaphore_decrement(&pi->ib_ready);  /* Thread blocked */
   ntm_semaphore_init("pcap_in_empty",pi->nbr, &pi->ib_empty);
   semaphore_decrement(&pi->ib_empty);
   if (gprof_pthread_create(&pi->input_thread, NULL, run_if_read, pi)) {
      log_msg(LOG_ERR, 1, "Error creating thread for i/f %d", pi->nbr);
      }
#else
#error *** Can only initialise timestamps for libcap in MULTI thread mode ***
#endif
   start_uptime_clock();
   return 1;  /* OK */
   }

#define PCAP_STATS_NO_RESET  0
unsigned int pkt_counts(int reset)  /* libpcap */
{
   int j, d;
   struct interface_info *pi;
   struct pcap_stat ps;
   char errbuf[PCAP_ERRBUF_SIZE];

   if (reset) {
      npackets_org = pkts;  lostpackets_org = drops;
      }

   pkts = drops = 0L;  /* Get total packets seen and dropped */
   for (j = 0; j != n_interfaces; ++j) {
      pi = pci[j];
      if (live_source) {
         if (pcap_stats(pi->pd,&ps)) {
            log_msg(LOG_ERR, 0, "pcap_stats(%d): %s\n",pi->nbr,errbuf);
            return 0;
            }
         d = ps.ps_drop;  /* Drops for this interface */
         }
      else d = 0;  /* No drops from a trace file! */

      pkts += pi->ipackets;  /* Counted in interface_read routines */
         /* Looks as though pkts and drops are zeroed each time
            we call pcap_stats()!               Nevil, 10 Aug 05 */
#if PCAP_STATS_NO_RESET
      drops += pi->idrops + d;
#else
      pi->idrops += d;  /* Remember drops for this interval */
      drops += pi->idrops;
#endif
      }
#if 0
   printf("pkt_counts(b): pkts=%u, drops=%u, npkts=%u, lost=%u\n",
      pkts, drops, npackets, lostpackets);  //IP++
#endif
   npackets = pkts - npackets_org;
   lostpackets = drops - lostpackets_org;
   return 1;
   } 

#endif  /* !NETFLOW */

/* ===== End of libpcap interface code ===== */

unsigned long iface_info(int if_nbr, int which)
{
   struct interface_info *pi;
   pi = pci[if_nbr-1];
   if (which == IFACE_LOST) 
      return pi->idrops + pi->noflowpackets;
   else if (which == IFACE_RATE)
      return pi->SampleRate;
   else return 0;
   }

void bump_noflowpkts(int if_nbr)
{
   ++noflowpackets;
   ++pci[if_nbr-1]->noflowpackets;  /* 1-org */
   }

void start_uptime_clock(void)
{
#if DAG_DIRECT  /* Dag code sets meter_start_time directly */
   sprintf(start_time_string, "%lu.%06lu",
      DAGT_S(meter_start_time),DAGT_US(meter_start_time));
   /* printf("start_time_string=%s\n", start_time_string);
      fflush(stdout);  /**/
   meter_start_us = ((double)DAGT_S(meter_start_time))*1000000.0
      + (double)DAGT_US(meter_start_time);
#elif LIBPCAP  /* libpcap code sets meter_start_us */
   Bit32 sec = meter_start_us/1000000.0;
   Bit32 usec = meter_start_us - sec*1000000.0;
   sprintf(start_time_string, "%lu.%06lu", sec,usec);
   meter_start_time.tv_sec = sec;  /* Used by uptime_s() */
   meter_start_time.tv_usec = usec;
#else
   struct timeval tv;
# if CR_DATA
   tv = last_ts;
# else  /* NETFLOW and LFAP_METER use time() */
   gettimeofday(&tv, (struct timezone *)0);
# endif
   meter_start_time = tv;
   sprintf(start_time_string, "%lu.%06lu",
      meter_start_time.tv_sec, meter_start_time.tv_usec);
   meter_start_us = ((double)meter_start_time.tv_sec)*1000000.0
      + (double)meter_start_time.tv_usec;
#endif
   last_t_sec = last_t_cs = 0;
   }

Bit32 uptime_s(void) /* seconds*/
{
#if DAG_DIRECT
   long long tsec = last_ts - meter_start_time;
   if (last_ts == 0 || meter_start_time == 0) return 0;
   else return DAGT_S(tsec);  
#elif LIBPCAP
   return (last_ts_us - meter_start_us)/1000000.0;
#elif NETFLOW || LFAP_METER  /* These use time() */
   struct timeval tv;
   gettimeofday(&tv, (struct timezone *)0);
   return tv.tv_sec - meter_start_time.tv_sec;
# else  /* Others use pkt timestamps from interface */
   if (last_t_sec == 0 || meter_start_time.tv_sec == 0) return 0;
   else return last_t_sec - meter_start_time.tv_sec;
#endif
   }

Bit32 uptime_cs(void) /* centiseconds */
{
#if DAG_DIRECT
   long long tsec = last_ts - meter_start_time;
   /*   printf("uptime_cs(): last_ts=%llu, meter_start_time=%llu\n",
	last_ts, meter_start_time);  /**/
   if (last_ts == 0 || meter_start_time == 0) return 0;
   else return DAGT_CS(tsec);  
#elif LIBPCAP
   return (last_ts_us - meter_start_us)/10000.0;
#elif NETFLOW || LFAP_METER  /* These use time() */
   struct timeval tv;
   gettimeofday(&tv, (struct timezone *)0);
   tv_sub(tv, meter_start_time);
   return tv.tv_sec*100 + tv.tv_usec/10000;
# else  /* Others use pkt timestamps from interface */
   if (last_t_sec == 0 || meter_start_time.tv_sec == 0) return 0;
   tv_sub(tv, meter_start_time);
   return tv.tv_sec*100 + tv.tv_usec/10000;
#endif
   }

#if 0  /* No longer used */
Bit32 seconds(ts_type nt)
{
#if DAG_DIRECT
   long long t = nt - meter_start_time;
   return DAGT_CS(t);
#else
   tv_sub(nt, meter_start_time);
   return nt.tv_sec*100 + (Bit32)(((double)nt.tv_usec)/10000);
#endif
   }

#if DAG_DIRECT
Bit32 centiseconds(long long nt)
{
   long long t = nt - meter_start_time;
   return DAGT_CS(t);
#else
Bit32 centiseconds(struct timeval nt)
{
   tv_sub(nt, meter_start_time);
   return ((double)nt.tv_sec)*100.0 + ((double)nt.tv_usec)/10000.0;
#endif
   }
#endif

#if DAG_DIRECT
double microseconds(long long nt)
/* Returns time as 'unix us.'  We save packet timestamps  in this form,
   IAT and TAT calculations give differences in us       Fri 4 Jun 04*/
{
   return ((double)DAGT_S(nt))*1000000.0 + (double)DAGT_US(nt);
   }
#else
double microseconds(struct timeval nt)
{
   return ((double)nt.tv_sec)*1000000.0 + (double)nt.tv_usec;
   }
#endif

Bit32 sysup_cs(double us)  /* Unix from microseconds */
{                      /* To compute stream LastTime */
   return (us - meter_start_us)/10000.0;
   }

struct timeval unix_tv(double us)  /* Unix from microseconds() */
{                               /* To comupte sysup ts for OAM */
   struct timeval ut;
   ut.tv_sec = us/1000000.0;
   ut.tv_usec = us - ut.tv_sec*1000000.0;
   return ut;
   }

struct timeval uptime_tv(double us)  /* Unix from microseconds() */
{                                 /* To comupte sysup ts for OAM */
   double du = us - meter_start_us;
   struct timeval ut;
   ut.tv_sec = du/1000000.0;
   ut.tv_usec = du - ut.tv_sec*1000000.0;
   return ut;
   }

void show_meter_time()
{
   char msg[60], *ts;
   ts = ctime((time_t *)&meter_start_time);
   sprintf(msg,"%lu seconds since %c%c%c%c:%c%c",
      uptime_s(),
      ts[11],ts[12],ts[14],ts[15], ts[17],ts[18]);
   display_msg(0,msg);
   }

extern int errno;
int snmp_dump_packet = 0;
#define MXINTERFACES 4

char interface_name[SZ_IFNAME*MXINTERFACES+1] = "";
   /* Interface name (used by met_vars.c) */
char r_community[SZ_IFNAME+1], w_community[SZ_IFNAME+1];

/* Help screen.  Add any new command line options here */
void print_help(char *prog)
{
   fprintf(stderr, "\n%s\n\n", version_descr);
   fprintf(stderr, "Usage: %s [OPTION] ..\n\n", prog);
   fprintf(stderr, 
      "  -i IFN \t Specify interface to monitor (maximum of 4)\n"
      "  -k     \t Disable keyboard input processing\n"
      "  -l     \t Use length field from IP headers\n"
      "  -m PRT \t Use port PRT to communicate with readers/managers\n"
#if NF_OCX_BGP
      "  -o     \t Use 'owner' ASNs instead of 'next-hop'\n"
#endif
#ifdef LFAP_METER
      "  -p1    \t Display flow info received from a CCE\n"
      "  -p2    \t Display messages sent between CCE and FAS (LfapMet)\n"
      "  -p4    \t Display raw messages (hexdump) received from CCE\n"
      "  -p8    \t log flow info received from a CCE in file "
                   "'LfapMet.logflowstats'\n"
      "  -p16   \t log messages sent between CCE and FAS in file "
                   "'LfapMet.logmessages'\n"
      "  -p32   \t log raw messages (hexdump) received from CCE in file"
                   "'LfapMet.loghexmessages' \n\t\t (useful for debugging)\n"
      "         \t -p options can be combined, e.g:\n"
      "         \t -p63 enables all\n"
      "         \t -p9 enables display & logging of flow info\n"
      "  -R RSC \t Set snmp read community for CCEs\n"
#endif
      "  -r RSC \t Set snmp read community to RSC\n"
      "  -s     \t Disable screen display\n"
      "  -w WSC \t Set snmp write community to WSC\n"
      "  -D     \t Run NeTraMet as a daemon (superset of -k -s)\n"
      "  -M LFN \t Set meter log file name to LFN\n"
      "\n  -K ppp \t Min ppp pKts before stream maps to flow\n"
      "\n     \t\t Memory allocation (defaults)\n"
      "  -f fff \t fff flows (%lu)\n"
      "  -u rrr \t rrr rUles (%lu)\n"
      "  -a aaa \t aaa pAcket data blocks (%lu)\n"
      "  -t ttt \t ttt IP sTreams (%lu)\n"
      "  -b bbb \t bbb stream data Blocks (%lu)\n"
      "  -v ddd \t ddd distributions (%lu)\n"
      "  -e eee \t eee Events (%lu)\n"
      "  -O ooo \t eee OAM data records (%lu)\n"
      "  -P ppp \t ppp Pkt structs (%lu)\n"
#if DAG_DIRECT
      "\n     \t\t DAG card options (defaults)\n"
      "  -g ttt \t card type, 0=ATM, 1=Ether, 2=PoSm, 3=Ext (3)\n"
      "  -I ppp \t ports per card (1)\n"
      "  -L nnn \t bytes captured, including link-layer headers (%lu)\n"
      "  -F     \t Fixed-length capture records (default)\n"
      "  -V     \t Variable-length capture records\n"
#endif
#if USER_INFO
      "  -U uuu \t uuu Users in userinfo table (%lu)\n"
#endif
      "\n"
      "A meter reader can collect flow data from many meters, and each meter\n"
      "may have its data retrieved by serveral meter readers.  Traffic flows\n"
      "of interest are defined by user-specified sets of rules\n"
      "\n"
      "For more information see the NeTraMet Reference Manual and User Guide\n"
      "\n"
      "Report bugs to netramet@list.auckland.ac.nz\n\n",
      mxflows, mxrules, mxstr_blocks, mxstreams, 
	   mxdistribs, mxdistevents, mxpktdatas, mxoamrecs, mxpkts
#if DAG_DIRECT
      , DAG_DEFAULT_SLEN
#endif
#if USER_INFO
      , mxusers
#endif
      );
   exit(-1);
   }

void check_struct_sizes(void)
{
   /* Using Bit16 and Bit32 instead of arrays of Bit8 requires
      us to keep these things correctly aligned in memory.
      gcc pads structures to multiples of 4 bytes, but other
      compilers might not, hence this check */
#if 1
   struct stream s;
# if MULTI
   printf("size(mutex)=%d\n\n", sizeof(pthread_mutex_t));
# endif
# if DAG_DIRECT
   printf("size(dag_rec) = %d\n", sizeof(struct dag_rec));
   if (sizeof(struct dag_rec) != 64)
      printf("   size(dag_rec) should be 64 bytes <<<<<\n");
   printf("\n");
# endif
   printf("size(struct pkt):\n"
      "   address=%d, pkt_key=%d, pkt=%d\n",
      sizeof(union address), sizeof(struct pkt_key), sizeof(struct pkt));
   printf("size(flowhash.h):\n"
      "   stream_name=%d, key=%d, flow_key=%d, rule=%d\n",
      sizeof(struct stream_name), sizeof(struct key),
      sizeof(struct flow_key), sizeof(struct rule));

   printf("   struct stream: offset of sfn = %d\n",
      (IntFromPtr)&s.sfn - (IntFromPtr)&s.next_hc);

   if (sizeof(struct pkt_key) % 4 != 0 ||
         sizeof(struct stream_name) % 4 != 0 ||
         sizeof(struct key) % 4 != 0 ||
         sizeof(struct flow_key) % 4 != 0 ) {
      printf("sizeof(struct) not a multiple of 4 bytes <<<<<\n");
      exit(-1);
      }
#endif
   }

int arg_int(void)
{
   if (isdigit(optarg[0])) return atoi(optarg);
   log_msg(LOG_ERR, 0, "option -%c: %s int value",
      optopt, optarg[0] == '-' ? "missing" : "invalid");
   return 0;
   }

char *arg_str(void)
{
   if (isalnum(optarg[0]) || strchr("/._~", optarg[0]) != NULL)
      return optarg;
   log_msg(LOG_ERR, 0, "option -%c: invalid string value", optopt);
   return "invalid";
   }


#define MX_SNMP_CLIENTS  10
Bit32 snmp_clients[MX_SNMP_CLIENTS];
int n_snmp_clients;

int main(int argc, char *argv[])
{
   int opt, sd, s_n, daemon, bgp_result, k,c;
   char *ap;
   struct sockaddr_in me;
   struct hostent *hostinfo;
   int bind_localhost;
   char *bind_host;
   struct utsname name;
#if DAG_DIRECT
   int dag_type = TT_EXT;
   int dag_varlen = DAG_DEFAULT_VARLEN;
   int dag_slen = DAG_DEFAULT_SLEN;
   int dag_ports = 1;
#endif
   int hyperthread_processors = 0;
   unsigned meter_mem;
   struct tms tbuf;

   mxpkts = DFMXPKTS;  mxflows = DFMXFLOWS;  mxrules = DFMXRULES;
   mxstreams = DFMXSTREAMS;  mxstr_blocks = DFMXSTRBLOCKS;
   mxdistribs = DFMXDISTRIBS;  mxdistevents = DFMXEVENTS;
   mxpktdatas = DFMXPKTDATS;  mxoamrecs = DFMXOAMRECS;
   mxusers = DFMXUSERS;  mxhlists = DFMXHLISTS;
   min_stream_PDUs = 0;  dnsrecsz_match = 1;
# if LOG_DNS_PKTS
   min_dnslogpktsz = 0;
#endif

   bind_localhost = n_snmp_clients = 0;

   if (argc < 2) {  /* Help Screen when called with no args */
      print_help(argv[0]);
      check_struct_sizes();
      }

   signal(SIGINT, sigint_handler);
   signal(SIGTERM, sigint_handler);
   signal(SIGUSR1, sigusr1_handler);
   signal(SIGUSR2, sigusr2_handler);

#if CR_DATA
   use_ip_length = 1;  /* Use IP header lengths */
   coral_set_api(CORAL_API_CELL);  /* Allows config file with proto rules */
#elif DAG_DATA || DAG_DIRECT
   use_ip_length = 0;  /* Use IP header lengths */
#endif

   display_enabled = kb_enabled = 1;  /* Enabled by default */
   daemon = 0;
   /* Default (CMU) communities are:  0 = "public", 1 = "proxy",
	 2 = "private", 3 = "regional", 4 = "core"
      We only allow "public" and "private" by default */
   communities[1] = communities[3] = communities[4] = "";
   for (n_interfaces = 0;  n_interfaces != MXINTERFACES; ++n_interfaces)
      pci[n_interfaces] = NULL;
   s_n = 1;  n_interfaces = 0;

   opterr = 0;  /* Turn off getopt error messages */
   for (;;) {
      if ((opt = getopt(argc, argv,
            "a:b:de:f:g:i:klm:n:op:r:st:u:v:w:"
            "A:BC:DEFG:H:I:K:L:M:N:O:P:R:S:T:U:VXYZ:" )) != -1) {
         switch(opt) {
         case 'a':
            mxpktdatas = arg_int();
            break;
	 case 'b':
	    mxstr_blocks = arg_int();
	    break;
	 case 'd':
	    snmp_dump_packet++;
	    break;
         case 'e':
            mxdistevents = arg_int();
            break;
     	 case 'f':
	    mxflows = arg_int();
	    break;
#if DAG_DIRECT
         case 'g':  /* -g dag type, default = 0 (atm) */
            dag_type = arg_int();
            if (dag_type < TT_ATM || dag_type > TT_EXT)
               log_msg(LOG_ERR, 0,
                  "Dag type (-g) not 0 (ATM), 1 (Ether) 2 (PoS) or 3 (Ext)");
            if (dag_type == TT_ATM)
               use_ip_length = 1;  /* Old ATM card doesn't have wlen */
            break;
#endif
	 case 'i':  /* -i name of interface to monitor */
            pci[n_interfaces] = (struct interface_info *)calloc(
               sizeof(struct interface_info), 1);
            strncpy(pci[n_interfaces]->name, arg_str(),SZ_IFNAME);
            pci[n_interfaces]->name[SZ_IFNAME] = '\0';
            pci[n_interfaces]->SampleRate =
               pci[n_interfaces]->sample_count = s_n;
#if DAG_DIRECT
            pci[n_interfaces]->dag_type = dag_type;
            pci[n_interfaces]->dag_slen = dag_slen;
            pci[n_interfaces]->dag_varlen = dag_varlen;
            pci[n_interfaces]->dag_ports = dag_ports;
#endif
            pci[n_interfaces]->nbr = n_interfaces+1;  /* 1-org */
            ++n_interfaces;
	    break;
	 case 'k':
	    kb_enabled = 0;  /* -k to disable keyboard */
	    break;
      	 case 'l':  /* Use 'Total Length' field from IP datagrams */
	    use_ip_length = 1;
	    break;
	 case 'm':
            au_snmp_port = arg_int();
            break;
 	 case 'n':
            s_n = arg_int();
            if (s_n <= 0)
               log_msg(LOG_ERR, 0, "sample rate (-n) must be > 0");
 	    break;
#if NF_OCX_BGP
	 case 'o':
	    use_owner_asns++;
	    break;
#endif
#ifdef LFAP_METER
         case 'p':  /* Optional arg, default handled by case ':' */
            lfap_info_level = arg_int();  /* Value was specified */
            if (lfap_info_level < 0) lfap_info_level = 0;
 	    break;
#endif
	 case 'r':
            strncpy(r_community, arg_str(),SZ_IFNAME);
            r_community[SZ_IFNAME] = '\0';
            communities[0] = r_community;
	    break;
	 case 's':
	    display_enabled = 0;  /* -s to disable screen */
	    break;
         case 't':
            mxstreams = arg_int();
            break;
	 case 'u':
	    mxrules = arg_int();
	    break;
 	 case 'v':
            mxdistribs = arg_int();
	    break;
	 case 'w':
            strncpy(w_community, arg_str(),SZ_IFNAME);
            w_community[SZ_IFNAME] = '\0';
 	    communities[2] = w_community;
            if (strcmp(w_community, "public") == 0) {
               /* 'public' is the default for the readonly community, set
                  it to somthing else, otherwise snmp's get_community will
                  trip over 'public' first, and never get write access! */
               strcpy(r_community,"PUBLIC");
               communities[0] = r_community;
               }
	    break;
	 case 'A':  /* Host name (or IP address) to accept SNMP from */
            bind_host = arg_str();
            hostinfo = gethostbyname(bind_host);
            if (hostinfo == NULL)
               log_msg(LOG_ERR, 1, "Couldn't gethost for %s", bind_host);
            else if (n_snmp_clients == MX_SNMP_CLIENTS)
               log_msg(LOG_ERR, 2,
                  "Can't have more than %d SNMP clients!", MX_SNMP_CLIENTS);
            else
               snmp_clients[n_snmp_clients++] = *(Bit32 *)hostinfo->h_addr;
	    break;
     	 case 'B':
            bind_localhost = 1;
	    break;
#if CR_DATA
         case 'C':  /* CoralReef option (other than source) */
            if (coral_config_command(get_str()) < 0)
               exit(-1);  /* arg must be in (single) quotes! */
            break;
#endif
         case 'D':
	    if (!trace_interval) {
               display_enabled = kb_enabled = 0;
               daemon++;
	       }
            else log_msg(LOG_WARNING, 0,
               "-D options reqires -T0 to run as daemon!");
            break;
         case 'E':
            dnsrecsz_match = 0;
            break;
#if LOG_DNS_PKTS || LOG_METER_STATS
         case 'G':  /* Specify name for log_dns|log_stats file */
            ap = arg_str();
            strcpy(ofname, ap);
            break;
     	 case 'Z':  /* Set min DNS record size to log */
	    min_dnslogpktsz = arg_int();
	    break;
#endif
     	 case 'H':
	    mxhlists = arg_int();
	    break;
#if !NF_CISCO_DATA && !LFAP_METER
     	 case 'K':
	    min_stream_PDUs = arg_int();
	    break;
#endif
         case 'M':  /* Specify name for meter.log file */
            ap = arg_str();
            logname = malloc(strlen(ap)+1);
            strcpy(logname, ap);
            break;
//T #if CR_DATA || DAG_DIRECT
         case 'N':  /* Stop after N*T s of tracefile.  0 => stop at EOF */
            crl_n_max = arg_int();
            break;
//T #endif
     	 case 'O':
	    mxoamrecs = arg_int();
	    break;
         case 'P':
            mxpkts = arg_int();
            break;
#ifdef LFAP_METER
 	 case 'R':
            strncpy(lfap_community, arg_str(),SZ_IFNAME);
            lfap_community[SZ_IFNAME-1] = '\0';
 	    break;
#endif
#if CR_DATA
         case 'S':  /* CoralReef source */
            pci[n_interfaces] = (struct interface_info *)calloc(
               sizeof(struct interface_info), 1);
            ap = arg_str();
            strncpy(pci[n_interfaces]->name, ap,SZ_IFNAME);
            pci[n_interfaces]->name[SZ_IFNAME] = '\0';
            pci[n_interfaces]->nbr = n_interfaces+1;  /* 1-org */
            pci[n_interfaces]->crl_src = coral_new_source(ap);
            if (pci[n_interfaces]->crl_src == NULL)
               log_msg(LOG_ERR, 1, "Failed to open coral source %s", ap);
            ++n_interfaces;
            break;
#endif
 //T #if CR_DATA || DAG_DIRECT
         case 'T':  /* Collection interval (seconds) for trace file.
                       T0 (default) implies 'use live source(s)' */
	    trace_interval = arg_int();
            break;
//T #endif
#if DAG_DIRECT
         case 'F':
            dag_varlen = 0;
            break;
         case 'I':
            dag_ports = arg_int();
            break;
         case 'L':
            dag_slen = arg_int();
            break;
         case 'V':
            dag_varlen = 1;
            break;
#endif
#if USER_INFO
         case 'U':
            mxusers = arg_int();
            break;
#endif
         case 'X':
            ++hyperthread_processors;
            break;
	 case 'Y':  /* Use sYsuptime OAM timestamps */
	    ++sysup_time_vals;
	    break;

         case ':':
#ifdef LFAP_METER
            if (optopt == 'p')  /* No value given */
               lfap_info_level = LFAP_INFLVL_FLOW|LFAP_INFLVL_MSG;
            else
#endif
               log_msg(LOG_ERR, FALSE, "option -%c: missing value", optopt);
            break;
         case '?':
         default:  /* Options left out by #defines above */
            if (optopt == '-')  /* -- option specified */
               print_help(argv[0]);
	    else log_msg(LOG_ERR, FALSE, "Invalid option: -%c"
               "  (--help displays usage summary)", optopt);
            break;
	    }
	 }
      else {  /* -- or end of args */
	/* printf("argc=%d, optind=%d, argv[optind-1]=>%s<\n",
              argc, optind, argv[optind-1]);  /* */
         if (strncmp(argv[optind-1],"--",2) == 0)  /* -- option specified */
            print_help(argv[0]);
         else if (optind < argc)
           log_msg(LOG_ERR, 0, "Option not preceded by -");
         break;  /* Don't try to parse non-option args */
         }
      }
   /* printf("XXX: errcnt=%d, optind=%d, argv[optind-1]=>%s<\n", 
         errcnt, optind, argv[optind-1]);  /* */
//   log_msg(LOG_WARNING, 0,"min_stream_PDUs=%d", min_stream_PDUs);  //MIN-PDUS

   if (errcnt != 0) log_msg(LOG_ERR, 1,
      "%s: %d parameter error(s)", argv[0], errcnt);

   if (daemon) {  /* User asked to run NeTraMet as daemon */
      switch (k = fork()) {
      case 0:  /* Child (left running on it's own) */
         break;
      case -1:
         fprintf(stderr, "Fork failed!!\n");
         exit(1);
      default:  /* Parent */
         exit(0);
         }
      setsid();  /* Move into a new session */
      }

#if NF_OCX_BGP
    InitSubnet();
    bgp_result = read_bgp_file("bgp.txt");
    if (bgp_result) {
       log_msg(LOG_ERR, 1,
          "read_bgp_file failed, bgp_result=%d", bgp_result);
       }
#endif

   /* Set up connections */
   sd = socket(AF_INET, SOCK_DGRAM, 0);
   if (sd < 0)
      log_msg(LOG_ERR, 1, "Couldn't get socket");

   memset(&me, 0, sizeof(me));
   me.sin_family = AF_INET;
      me.sin_addr.s_addr = INADDR_ANY;
   if (bind_localhost) {
      hostinfo = gethostbyname("localhost");
      if (hostinfo == NULL)
         log_msg(LOG_ERR, 1, "Couldn't reslove 'localhost'!");
      me.sin_addr = *(struct in_addr *) hostinfo->h_addr;
      }
   else me.sin_addr.s_addr = INADDR_ANY;

   me.sin_port = htons(SNMP_PORT);
   if (bind(sd, (struct sockaddr *)&me, sizeof(me)) != 0)
      log_msg(LOG_ERR, 2,  /* SNMP_PORT defined in snmplib/snmp.h */
         "Couldn't bind port %d: %s", SNMP_PORT,strerror(errno));
   if (n_interfaces == 0) {
      pci[0] = 
         (struct interface_info *)calloc(sizeof(struct interface_info),1);
      pci[0]->nbr = n_interfaces = 1;
      }

#ifdef LFAP_METER
   if (!start_lfap(&name)) return 0;  /* Fail */
#endif

   clear_pkt_stats = 1;  sproctime = 0;
   get_sys_info(hyperthread_processors);
   clocktime_org = sclocktime = times(&tbuf);
   av_idle1000 = proctime_org = sproctime = 0;
#if MULTI
   init_mutexes();

   ntm_semaphore_init("osp_semaphore",0, &osp_semaphore);
   semaphore_decrement(&osp_semaphore);  /* Thread blocked */
   if (gprof_pthread_create(&osp_thread, NULL, run_osp, NULL)) {
      log_msg(LOG_ERR, 1, "Error creating osp thread");
      }

   for (k = 0; k != N_PME_THREADS; ++k) {
      struct pme_data *pd = &pme_data_buf[k];
      memset(pd, 0, sizeof(struct pme_data));
      ntm_semaphore_init("buf_full",k+1, &pd->buf_full);
      ntm_semaphore_init("buf_empty",k+1, &pd->buf_empty);
      semaphore_decrement(&pd->buf_full);  /* Thread blocked */
      semaphore_decrement(&pd->buf_empty);
      pd->hash_group = k;
      if (gprof_pthread_create(&pd->pme_thread, NULL, run_pme, pd)) {
         log_msg(LOG_ERR, 1, "Error creating pme %d thread", k);
         }
      }

   /* Allow init_monitor() to open default ruleset */
   ntm_semaphore_init("running_rulesets",0, &r_rts_sem);
   semaphore_decrement(&r_rts_sem);
   for (k = 0; k != N_PME_THREADS; ++k)
      ntm_semaphore_up("init", &r_rts_sem);
#endif

   meter_mem = init_monitor(n_interfaces);
#if NETFLOW || LFAP_METER  /* These use time() */
   start_uptime_clock();
#endif
   init_snmp();
   uname(&name);

   log_msg(LOG_WARNING, 0, "Starting %s", version_descr);
   phys_mem = phys_mem/(1024*1024);  meter_mem = meter_mem/(1024*1024);
   log_msg(LOG_WARNING, 0,
      "Running on %s (%u processors, %u MiB memory), using %u MiB", 
      name.nodename, n_procs, phys_mem, meter_mem);
   if ((k = meter_mem*100/phys_mem) > 50) log_msg(LOG_WARNING, 0,
      "Meter is using %u%% of pysical memory, beware of paging load", k);

   ap = interface_name;  k = sizeof(interface_name);
   for (c = 0; c != n_interfaces; ++c) {
      if (!init_interface(pci[c])) exit(3);
      if (strlen(pci[c]->name)+3 < k) {
         if (c != 0) ap = strmov(ap,", ");
         ap = strmov(ap,pci[c]->name);
         k -= strlen(pci[c]->name)+2;
         }
      }
   *ap = '\0';

#if NETFLOW
   log_msg(LOG_WARNING, 0, "Metering port(s) %s", interface_name);
#else
   log_msg(LOG_WARNING, 0, "Metering interface(s) %s", interface_name);
#endif

   setuid(getuid());
   receive(sd,n_interfaces);
   }

void zero_pkt_stats()
{
   struct tms tbuf;
#if LOG_THREAD_PROCTIMES
   time_t t;  char *ts, ftb[32];
   int j;
   Bit32 pt, pc_proc;

   time(&t);  ts = ctime(&t);
   strncpy(&ftb[0],  &ts[11], 9);  /* 17:31:42_ */
   strncpy(&ftb[9],  &ts[0],  4);  /* Thu_ */
   strncpy(&ftb[13], &ts[8],  3);  /* 23_  */
   strncpy(&ftb[16], &ts[4],  4);  /* Sep_ */
   strncpy(&ftb[20], &ts[20], 4);  /* 1997 */
   ftb[24] = '\0';

   if (threads_log == NULL && sproctime != 0) {
      if ((threads_log = fopen("threads.log", "a")) == NULL)
         log_msg(LOG_ERR, 1, "Couldn't open threads.log <<<<<");
      fprintf(threads_log, "%s #Threads: 1=%s", ftb, thread_name[0]);
      for (j = 1; j != t_log_n; ++j)
         fprintf(threads_log, " %d=%s", j+1, thread_name[j]);
      fprintf(threads_log, "\n");
      }

   if(threads_log != NULL) {
      fprintf(threads_log, "%s ", ftb);
      pt = sclocktime-clocktime_org;
      if (pt == 0) pt = 1;  /* Don't divide by 0 */
      for (j = 0; j != t_log_n; ++j) {
         fprintf(threads_log, " %d", (thread_proctime[j]-thread_proctime_org[j])*1000/pt);
         thread_proctime_org[j] = thread_proctime[j];
         }
      fprintf(threads_log, "\n");
      fflush(threads_log);
      }
#endif   

   clocktime_org = sclocktime;  proctime_org = sproctime;
   min_idle1000 = 1000L;
   noflowpackets = 0;
   pkt_counts(1);  /* Reset origins */
   stats_time = spackets = 0L;
   max_pkt_rate = 0;
   clear_pkt_stats = 0;

   n_lost_streams = n_lost_flows = 0;
   mx_active_streams = mx_active_flows = 0;
   }

int chart_interface = 0;  /* Use SampleRate from first interface */
unsigned int bkgi;  /* Seconds before next run of backgound process */
#define BKG_INTERVAL  30  /* Seconds */
int gci;

//T #if CR_DATA || DAG_DIRECT
unsigned int mtrlogi = 30;  /* Seconds before next run of meter log process */
/* #define LOG_INTERVAL  60  /* Seconds (1 min) */
#define LOG_INTERVAL  300  /* Seconds (5 min) */
//T #endif

void one_second_process(void)
{
   int x;
   clock_t rt,pt, clocktime, proctime;
   struct tms tbuf;
   unsigned long idle1000, pd, cd;
   unsigned char p;
   struct mgr_rec *mip;
   struct rdr_rec *cip;
   char msg[100];
//T #if CR_DATA || DAG_DIRECT
   int i, ifd, flags;
   char *mp, tsbuf[30], ibuf[40];
//T #endif
   Bit32 act_streams, act_flows;
   Bit32 osp_proct;

#if UX_TESTING
   printf("+");
#endif
   if (request_stop) stop_meter(0);
   ++stats_time;

   clocktime = times(&tbuf);  /* Times for self + timed-out children */
#if !MULTI
   proctime = tbuf.tms_utime+tbuf.tms_stime;
#else
   osp_proct = tbuf.tms_utime+tbuf.tms_stime;
   total_thread_proct += (osp_proct - last_osp_proct);
# if LOG_THREAD_PROCTIMES
   thread_proctime[osp_tn] += (osp_proct - last_osp_proct);
# endif   
   last_osp_proct = osp_proct;
   proctime = total_thread_proct;
#endif

   if (clocktime > sclocktime) {
      pd = proctime-sproctime;  cd = n_procs*(clocktime-sclocktime);
      if (pd <= cd) {
         idle1000 = 1000L - pd*1000L/cd;
         if (idle1000 < min_idle1000) min_idle1000 = idle1000;
         pd = proctime-proctime_org;  cd = n_procs*(clocktime-clocktime_org);
         if (pd <= cd)
            av_idle1000 = 1000L - pd*1000L/cd;
         }
      /* printf("last_t_s=%u, idle=%u, min_idle=%u, av_idle=%u\n",
        last_t_sec, idle1000, min_idle1000, av_idle1000);  /**/
      }
   sclocktime = clocktime;  sproctime = proctime;
   if (clear_pkt_stats) zero_pkt_stats();

   pkt_counts(0);

   pd = (npackets-spackets)*pci[chart_interface]->SampleRate;
   if (pd > max_pkt_rate) max_pkt_rate = pd;
#if 0
   if (stats_time != 0) { //19
      printf("--- osp(%d):  stats_time=%lu, npackets=%lu, rate=%.2f kp/s"
            ", aps=%lu, mps=%lu\n", 
         last_t_sec, stats_time, npackets,(double)npackets/(1000.0*stats_time),
         pd, max_pkt_rate );
      fflush(stdout);
      }
#endif
   spackets = npackets;

   act_streams = mxstreams - n_free_streams;
   if (act_streams > mx_active_streams) mx_active_streams = act_streams;
   act_flows = active_flows();
   if (act_flows > mx_active_flows) mx_active_flows = act_flows;

#if LOG_METER_STATS
   log_stats(last_t_sec, pd, lostpackets, 
      idle1000, act_streams, act_flows);
#endif

   check_events(uptime_s());  /* uptime in seconds */

   if (--gci == 0) {
#if UX_TESTING
     printf("g");
#endif
      garbage_collect(1);  /* Routine incremental collection */
      gci = gc_interval;
      }

#if CR_DATA || DAG_DIRECT
   if (--mtrlogi == 0 && live_source) {  /* Write regular meter log entry */
      int cpb, mxcpb;
      for (mp = msg, mxcpb = i = 0; i != n_interfaces; ++i) {
         cpb = pci[i]->nblocks == 0 ? 0 :
            pci[i]->nrecords/pci[i]->nblocks;
         fmt_ts(tsbuf, pci[i]->card_ts);
         sprintf(ibuf, "%d:  %s, %lu badts, %lu cpb, %lu_%lu^%lu, ",
            i+1, tsbuf, pci[i]->badtspkts, cpb, 
            pci[i]->nblocks, pci[i]->mx_empty, pci[i]->mx_full);
# if DAG_DIRECT
         if (pci[i]->nblocks == 0) {  /* Dead interface */
            log_msg(LOG_ERR, 0, "Try to restart i/f %d", i+1);
            if (pci[i]->restarts) log_msg(LOG_ERR, 111,
               "No data after previous restart, shutting down");
            else if (open_dag_direct(pci[i])) {
               log_msg(LOG_ERR, 0, "Restarted OK");
               ++pci[i]->restarts;
               }
            else log_msg(LOG_ERR, 112, "Restart failed, shutting down");
	    }
# endif
         pci[i]->nrecords = pci[i]->nblocks =
            pci[i]->mx_empty = pci[i]->mx_full = 0;  
         if (cpb > mxcpb) mxcpb = cpb;
         mp = strmov(mp, ibuf);
         }
      mp[-2] = '\0';
      log_msg(LOG_WARNING, 0, "%s. %u delta_OKs", msg, n_delta_OKs);
      if (n_delta_OKs < 100 && last_n_delta_OKs > 500) {
         log_msg(LOG_ERR, 113,
            "Not enough matched packet pairs, shutting down");
         }
      else {
         last_n_delta_OKs = n_delta_OKs;  n_delta_OKs = 0;
         }
/*      show_stream_hash(0);  /*PPP*/
      mtrlogi = LOG_INTERVAL;

      if (mxcpb < TARGET_CPB) {  /* Should we adjust the select time? */
         if (select_us < MX_SELECT_US) {
            select_us *= 2;
# if DAG_DIRECT
            select_time = US_DAGT(select_us);
# elif CR_DATA
            select_tv.tv_usec = select_us;
# endif
            log_msg(LOG_WARNING, 0, "--* select_us = %d", select_us);
            }
         }
      else if (mxcpb >= 2*TARGET_CPB) {
         if (select_us > MN_SELECT_US) {
            select_us /= 2;
# if DAG_DIRECT
            select_time = US_DAGT(select_us);
# elif CR_DATA
            select_tv.tv_usec = select_us;
# endif
            log_msg(LOG_WARNING, 0, "--/ select_us = %d", select_us);
            }
         }
      }
#endif  /* CR_DATA || DAG_DIRECT */

   if (--bkgi == 0) {  /* Check % of flows active */
#if UX_TESTING
      printf("b\n");
#endif
      p = (unsigned long)active_flows()*100/(mxflows);

      if (p > FloodMark && FloodMode != TV_TRUE &&
            FloodMark > 0 && FloodMark < 100) {
         FloodMode = TV_TRUE;  /* Stop creating new flow records */
         log_msg(LOG_WARNING, 0, "Meter in Flood mode");
	 }
      else for (x = 0; x != sizeof(mi)/sizeof(struct mgr_rec); ++x) {
         mip = &mi[x];
         if (mip->mi_Status != RS_ACTIVE
               || mip->mi_RunningStandby == TV_TRUE)
            continue;
	 else if (p > mip->mi_HighWaterMark &&
	       mip->mi_HighWaterMark > 0 && 
               mip->mi_HighWaterMark < 100 &&
	       mip->mi_StandbyRuleSet != mip->mi_CurrentRuleSet &&
               (mip->mi_StandbyRuleSet != 0 &&
                  ri[mip->mi_StandbyRuleSet-1].ri_Status == RS_ACTIVE)
               ) {
            open_rule_set(mip->mi_CurrentRuleSet, 0);  /* Close */
	    open_rule_set(mip->mi_StandbyRuleSet, 1);  /* Open */
            mip->mi_RunningStandby = TV_TRUE;
            log_msg(LOG_WARNING, 0, "Manager %d running Standby", x+1);
	    }
	 else if (p > HighWaterMark*2/3)
	    more_garbage();
         }
      pd = uptime_cs();
      for (x = 0; x != sizeof(ci)/sizeof(struct rdr_rec); ++x) {
         cip = &ci[x];
         if (cip->ci_Status != RS_ACTIVE || cip->ci_Timeout == 0)
            continue;
         if ((pd - cip->ci_LastTime)/100 > cip->ci_Timeout)
            cip->ci_Status = RS_UNUSED;  /* Timed out */
         }
      bkgi = BKG_INTERVAL;
      }
#if UX_TESTING
   fflush(stdout);
#endif
   }

handle_keyboard()
{
   char kb_buf[25];
   int ch;
   if (fgets(kb_buf, sizeof kb_buf, stdin) == NULL)
      return;  /* Error or EOF */
   if ((ch = kb_buf[0]) == 27 && kb_buf[1] == 27)  /* ESC ESC */
      stop_meter(0);
   switch (tolower(ch)) {
   case 'v':
      printf("\n%s\n",version_descr);
      break;
#if CR_DATA
   case '*':
      if (coral_start_all() < 0)  /* Also synchronises all sources */
         log_msg(LOG_ERR, 0, "coral_start failed");
      break;
#endif
   default:
      handle_kb(ch);
      break;
      }
   }

void snmp_read_sp(int sd);  /* Handles meter's SNMP requests */

#if !NETFLOW && !LFAP_METER
int non_live_source(int sd)  /* New (MULTI) version, runs as OB */
{
   fd_set fdset;
   struct timeval t;
   int j, eof, width, count;
   int last_state = -1;
#if DEBUG_TF_READ
   char tsbuf[30];
#endif

   width = STDIN_FILENO;  /* Determine size of fd_set */
   if (sd > width) width = sd;
   ++width;
   FD_ZERO(&fdset);
   t.tv_sec = 0;  

   for (;;) {
#if DEBUG_TF_READ
      if (trace_state != last_state) {
         fmt_ts(tsbuf, last_ts_us);
         printf("Main loop: state=%d, last_state=%d,  "
               "crl_n_count=%d, full=%d, empty=%d\n"
               "       last_t_sec=%d, last_ts=%s\n",
            trace_state, last_state, crl_n_count, 
               t_semaphore_value(&merge_sync_full),
               t_semaphore_value(&merge_sync_empty),
               last_t_sec, tsbuf);
         fflush(stdout);
         }
#endif

      switch (trace_state) {  /* Reading from trace file */
      case CT_WAIT_RULES:
         /* met_vars will change to CT_RULES_READY */
         break;
      case CT_RULES_READY:
         trace_state = CT_WAIT_FLOWS_READ;
         break;
      case CT_PROCESS_FLOWS:  /* 2 */
       	 if (last_state == CT_WAIT_FLOWS_READ ||
	       last_state == CT_RULES_READY) {
            /* Waited on sync_empty when entering WAIT_FLOWS_READ */
            ntm_semaphore_up("nls", &merge_sync_full);
	    break;  /* OK, now read some more */
	    }
      	 else ntm_semaphore_down("nls", &merge_sync_empty);

         for (eof = j = 0; j != n_interfaces; ++j) {
#if DAG_DIRECT
# if HAVE_LIBZ
            if (pci[j]->gfp == NULL) {
# else
            if (pci[j]->t_fd == -1) {
# endif
#elif LIBPCAP
	      //T    r -i testdata-01.bpf -wtest -m2161 -T5 -N3
            if (pci[j]->pd == NULL) {
               printf("End of libpcap trace file\n");
#endif
               trace_state = CT_TRACE_EOF;  /* Dummy up EOF */
               break;
               }
            }

         if (trace_state == CT_TRACE_EOF) break;

         if (trace_count <= 0) {  /* Reached -T interval */
/*            show_memory();  /* Show memory every -T interval */
/*            show_stream_hash();  */
            trace_count += trace_interval;
            if (crl_n_max) {  /* Stop after -N meter readings */
               if (++crl_n_count == crl_n_max) {
                 trace_state = CT_TRACE_EOF;  /* Dummy up EOF */
                 }
               else
                  trace_state = CT_WAIT_FLOWS_READ;
               }
            else trace_state = CT_WAIT_FLOWS_READ;

            break;  /* Don't signal sync_full until we've read the
               flow table, and switched ack to PROCESS_FLOWS */
            }
         ntm_semaphore_up("nls", &merge_sync_full);
         break;
      case CT_WAIT_FLOWS_READ:  /* 3 */
         /* NeMaC will change to CT_PROCESS_FLOWS */
         break;
      case CT_TRACE_EOF:
         /* NeMaC will change to CT_SHUTDOWN */
         break;
      case CT_SHUTDOWN:
         stop_meter(0);
         break;
         }
      last_state = trace_state;

      t.tv_usec = 10000;  /* 0.01 s  Keep snmp and keyboard alive */
      FD_SET(sd, &fdset);
      if (kb_enabled) FD_SET(STDIN_FILENO, &fdset);  /* stdin */
//T printf("nls(1): about to select - - -\n");  fflush(stdout);  //T
      count = select(width, &fdset, 0, 0, &t);
//T  printf("nls(2): t=%d.%d, count=%d\n", t.tv_sec,t.tv_usec, count);
//T fflush(stdout);  //T
      if (count > 0) {
         if (FD_ISSET(sd, &fdset))
	    snmp_read_sp(sd);
         if (kb_enabled && FD_ISSET(STDIN_FILENO, &fdset))  /* stdin */
            handle_keyboard();
         }
      else switch (count) {
      case 0:
	 break;
      case -1:
	 if (errno == EINTR) continue;
	 else log_msg(LOG_ERR, 0,
            "select returned %d, %s", count, strerror(errno));
	 return 0;
      default:
	 log_msg(LOG_ERR, 0, "select returned %d", count);
	 return 0;
	 }
      }
   }
#endif /* !NETFLOW && !LFAP_METER */

#if MULTI
# if DAG_DIRECT
#if !NO_MERGE_THREAD 
void *run_dag_merge(void *arg)
{
   struct timeval timeout;

   init_hist(&dm_hist, "dag_mg");
   dag_merge();  /* Just keep running */
#  if 0  /* select() doesn't work properly in linux/pthreads! */
   for (;;) {
         /* Block until semaphore comes up, -> pme buffer empty */
      dag_merge();  /* Return when ready for next block */

      while (read_live_block(waiting_live_source)) {
         timeout.tv_sec = 0;  timeout.tv_usec = select_us;
         select(FD_SETSIZE, 0, 0, 0, &timeout);
         }
      }
   return NULL;  /* Keep compiler happy */
#  endif
   }
#endif

# elif LIBPCAP
void *run_input_merge(void *arg)
{
   init_hist(&dm_hist, "inp_mg");
   input_merge();  /* Just keep running */
   }

# endif
#endif


int receive(int sd,int n_interfaces)
{
   fd_set fdset;
   int j, width, count;
   struct timeval t;
#if NETFLOW || LFAP_METER|| CR_DATA 
   time_t now,prev;
#endif
#if DAG_DIRECT
   int i_count = 0;
#endif
# if MULTI
   pthread_t pkt_read_thread;
   Bit32 o_b_proct,
      last_o_b_proct = 0;
   struct tms tbuf;
# endif

#define OB_TIMING_TEST  0
#if OB_TIMING_TEST
   struct timeval t_ob;
   double last_d_ob, d_ob;
#endif

#if WATCH_RUN_LIGHT
   struct timeval rlt;
   int last_rlt_sec = 0;
   int n_rl_warns = 0;
#define RUN_LIGHT_MAX_TIME  60  /* Seconds */
   /* Two Dag cards can start a minute apart, and take a few
      seconds for the busy one to catch up, that's why we
      wait so long before saying 'no packets!'  */
#define RUN_LIGHT_MAX_WARNS 3  /* exit() after 3 MAX_TIMEs */
#endif

#if LOG_THREAD_PROCTIMES
   int this_tn = assign_thr_log_nbr();
   sprintf(thread_name[this_tn], "outer_blk");
   thread_proctime_org[this_tn] = thread_proctime[this_tn] = 0;
#endif   
/*   printf("running receive():\n");  fflush(stdout);  /* */

   gci = gc_interval;  /* Garbage collect interval */
   bkgi = BKG_INTERVAL;  /* Background interval */
   gc_f = (mxflows)/100;  /* Flow indexes to check */
   if (gc_f < 4) gc_f = 4;

#if CR_DATA
   init_live_sources();  /* Read some cells from each interface */
   coral_merge();  /* Return when ready for next block */

#elif DAG_DIRECT
   select_time = US_DAGT(select_us);

# if MULTI
   if (!live_source) {
      ntm_semaphore_init("merge_sync_full",0, &merge_sync_full);
      ntm_semaphore_init("merge_sync_empty",0, &merge_sync_empty);
      semaphore_decrement(&merge_sync_full);  /* Thread blocked */
      semaphore_decrement(&merge_sync_empty);
      for (j = 0; j != n_interfaces; ++j) {
         next_trace_record(pci[j]);
         }
      }
   else init_live_sources();  /* Read first block, set meter_start_time */

#  if !NO_MERGE_THREAD 
   if (gprof_pthread_create(&pkt_read_thread, NULL, run_dag_merge, NULL)) {
      log_msg(LOG_ERR, 1, "Error creating read thread");
      }
#  endif
# else  /* !MULTI */
    dag_merge();  /* Return when ready for next block */
# endif
   if (!live_source) non_live_source(sd);

#elif !NETFLOW && !LFAP_METER
# if MULTI
   if (!live_source) {
      ntm_semaphore_init("merge_sync_full",0, &merge_sync_full);
      ntm_semaphore_init("merge_sync_empty",0, &merge_sync_empty);
      semaphore_decrement(&merge_sync_full);  /* Thread blocked */
      semaphore_decrement(&merge_sync_empty);
      }

#  if !NO_MERGE_THREAD 
   if (gprof_pthread_create(&pkt_read_thread, NULL,
         run_input_merge, NULL))
      log_msg(LOG_ERR, 1, "Error creating read thread");
#  endif
# endif
   if (!live_source) non_live_source(sd);

#endif

   width = STDIN_FILENO;  /* Determine size of fd_set */
   if (sd > width) width = sd;
#if !CYGWIN32
   for (j = 0; j != n_interfaces; ++j)
      if (pci[j]->fd > width) width = pci[j]->fd;
#endif
   ++width;
#if NETFLOW || LFAP_METER
   time(&prev);
#endif

#if OB_TIMING_TEST
   gettimeofday(&t_ob, (struct timezone *)0);
   last_d_ob = t_ob.tv_sec + t_ob.tv_usec/1000000;
#endif
   for (;;) {
#if WATCH_RUN_LIGHT
      if (got_USR2) {
         printf(".");  fflush(stdout);
         }
      gettimeofday(&rlt, (struct timezone *)0);
      if (rlt.tv_sec > last_rlt_sec) {
         if (rlt.tv_sec - last_t_sec > RUN_LIGHT_MAX_TIME) {
            log_msg(LOG_WARNING, 0,
               "Run light out for %ds, warning %d",
               rlt.tv_sec-last_t_sec, n_rl_warns);
            if (++n_rl_warns == RUN_LIGHT_MAX_WARNS)
               log_msg(LOG_ERR, 111, "Stopped reading packets <<<<");
# if DAG_HW_RESET
            for (j = 0; j != n_interfaces; ++j) {
               if (pci[j]->nblocks == pci[j]->last_nblocks &&
                     pci[j]->running) {  /* No blocks read for 2s */
                  log_msg(LOG_WARNING, 0,
                     "No blocks read for 2s, i/f %d", j+1);
                  dag_reset(j);  /* Try to reset the Dag card */
                  }
               pci[j]->last_nblocks = pci[j]->nblocks;
               }
# endif
            }
         else n_rl_warns = 0;
         last_rlt_sec = rlt.tv_sec;
         }
#endif  /* WATCH_RUN_LIGHT */

      FD_ZERO(&fdset);
      t.tv_sec = 0;  

#if CR_DATA
      if (read_live_block(waiting_live_source))
         coral_merge();  /* Return when ready for next block */
      t.tv_usec = select_us;

#elif DAG_DIRECT  /* !CR_DATA */
#if MULTI
      t.tv_usec = 5000;  /* 5 ms */
#else
      if (read_live_block(waiting_live_source)) {
         dag_merge();  /* Return when ready for next block */
         }
      t.tv_usec = select_us;
#endif

#elif LFAP_METER
      t.tv_usec = 250000;  /* 0.25 s */
      for (j = 0; j != n_interfaces; ++j) {
         tick(pci[j]);
         if (pci[j]->fd != -1) {
            FD_SET(pci[j]->fd,&fdset);
            if (pci[j]->fd >= width) width = pci[j]->fd + 1;
            }
         }
      FD_SET(lfap_server_socket,&fdset);
      if (lfap_server_socket >= width) width = lfap_server_socket + 1;

#elif LIBPCAP
      t.tv_usec = 250000;  /* 0.25 s */

#elif CYGWIN32
      t.tv_usec =  15000;  /* 15 ms */
# if 0  /* Shouldn't need to do this - provided cygwin implements pthreads */
      for (j = 0; j != n_interfaces; ++j)  /* Read interfaces every cycle */
         interface_read(pci[j]);  /* Can block for several seconds !!!!!! */
# endif
#endif

      if (request_stop) stop_meter(0);

      FD_SET(sd, &fdset);
      if (kb_enabled) FD_SET(STDIN_FILENO, &fdset);  /* stdin */

      count = select(width, &fdset, 0, 0, &t);
      if (count > 0) {
/*  printf("O/B .. t=%d.%03d, count=%d\n",  t.tv_sec,t.tv_usec, count);  /* $$$ */
#if OB_TIMING_TEST
   gettimeofday(&t_ob, (struct timezone *)0);
   d_ob = t_ob.tv_sec + t_ob.tv_usec/1000000;
   printf("\nOB: delta=%.6f ", d_ob-last_d_ob);  fflush(stdout);
   last_d_ob = d_ob;
#endif

#if LFAP_METER
         if (FD_ISSET(lfap_server_socket, &fdset)) {
            printf("client wants to connect.\n");
            /* Apparently someone knocking on my door ..
               find a free interface */
            for (j = 0; j < n_interfaces; ++j) {
               printf("trying i/f %i.\n",j);
               if (pci[j]->fd == -1) {
                  printf("i/f %i is free.\n",j);  /* Found a free one */
                  pci[j]->fd = accept(lfap_server_socket,NULL,NULL);
                  pci[j]->fasinfo.conn = pci[j]->fd;
                  j = n_interfaces + 1;
                  }
               }
            if (j == n_interfaces) {
               int sock;
               LFAPHeader *lfap;
               LFAP_IE_Header* ie;

               printf("No interfaces left !\n");
               /* Dirty hack to refuse connections, need this in LFAPv5 ? */
               sock = accept(lfap_server_socket, NULL, NULL);
               /* Assume it is the right one ... */
               lfap = newLFAPMessage(LFAP_OPCODE_AR, LFAP_STATUS_SUCCESS, 1);
               /* Fill in command code IE */
               ie = newIE(LFAP_IE_COMMAND_CODE,4);
               putIEDword(ie, (Bit32)LFAP_CMD_CONNECTION_ACCEPTED, 0);
               addIE(&lfap, ie);
               free(ie);
               sendLFAPMessage(lfap, sock);
               free(lfap);
               close(sock);
               }
	    }
#endif

#if !CYGWIN32 && !CR_DATA
         for (j = 0; j != n_interfaces; ++j) {
# if DAG_DIRECT || LIBPCAP
            if (FD_ISSET(pci[j]->fd, &fdset)) {
	       printf(">>> select returned 'ready' for i/f %d!\n", j);
	       fflush(stdout);
               }
# elif LFAP_METER
            if(pci[j]->fd != -1) {
               if (FD_ISSET(pci[j]->fd, &fdset)) interface_read(pci[j]);
               }
# else
            if (FD_ISSET(pci[j]->fd, &fdset)) {
               interface_read(pci[j]);
               }
# endif
	    }
#endif
         if (FD_ISSET(sd, &fdset))
	    snmp_read_sp(sd);
         if (kb_enabled && FD_ISSET(STDIN_FILENO, &fdset))  /* stdin */
            handle_keyboard();
         }
      else switch (count) {
      case 0:
	 break;
      case -1:
	 if (errno == EINTR) continue;
	 else log_msg(LOG_ERR, 0, "select returned %d (not EINTR)", count);
	 return 0;
      default:
	 log_msg(LOG_ERR, 0, "select returned %d", count);
	 return 0;
	 }

#if NETFLOW || LFAP_METER
      time(&now);
      if (now != prev) {
         one_second_process();
         prev = now;
         }
#endif

#if MULTI
      times(&tbuf);
      o_b_proct = tbuf.tms_utime+tbuf.tms_stime;
      total_thread_proct += (o_b_proct - last_o_b_proct);
#if LOG_THREAD_PROCTIMES
      thread_proctime[this_tn] += (o_b_proct - last_o_b_proct);
#endif   
      last_o_b_proct = o_b_proct;
#endif
      }
   return 1;
   }

Bit32 snmp_peer_addr;  /* IPv4 address of SNMP client */

extern n_dds_read;  /* In met_vars.c */
void dyn_dst_init(void);  /* Clear list of dynamic distribs to be reset */

void snmp_read_sp(int sd)
{
   struct sockaddr_in from;
   int length, out_length, fromlength, count, j;
   Bit8 packet[1500], outpacket[1520];  /* Leave some space just in case */
   char snmp_peer_name[50];  /* Name of host which sent the snmp request */

   fromlength = sizeof from;
   length = recvfrom(sd, packet, 1500, 0, 
      (struct sockaddr *)&from, (socklen_t *)&fromlength);
   if (length == -1) {
      log_msg(LOG_ERR, 0,
         "snmp_read_sp() recvfrom failed: %s", strerror(errno));
      return;
      }

   if (n_snmp_clients != 0) {  /* From client in list? */
      for (j = 0;  j != n_snmp_clients;  ++j) {
         if (from.sin_addr.s_addr == snmp_clients[j])
            break;
         }
      if (j == n_snmp_clients)
         return;  /* Client not in list; just ignore it */
      }

   if (snmp_dump_packet) {
      strcpy(snmp_peer_name,inet_ntoa(from.sin_addr));
      printf("received %d bytes from %s:\n", length, snmp_peer_name);
      for (count = 0; count < length; count++) {
         printf("%02X ", packet[count]);
	 if ((count % 16) == 15) printf("\n");
	 else if ((count % 4) == 3) printf(" ");
	 }
      printf("\n\n");
      }

   out_length = 1500;
   if (snmp_agent_parse(packet, length, outpacket, &out_length, 
         from.sin_addr.s_addr)) {
      if (n_dds_read != 0) {
         /* snmp handler leaves dyn_dst mutexes locked if a
            package doesn't fit into the SNMP PDU  */
         dyn_dst_init();  /* We make sure they're not left locked! */
         }
      if (snmp_dump_packet) {
	 printf("sent %d bytes to %s:\n", out_length, snmp_peer_name);
	 for (count = 0; count < out_length; count++) {
            printf("%02X ", outpacket[count]);
	    if ((count % 16) == 15) printf("\n");
	    }
	    printf("\n\n");
	 }
      if (sendto(sd, (char *)outpacket, out_length, 0, 
            (struct sockaddr *)&from, sizeof(from)) < 0) {
         log_msg(LOG_ERR, 0,
            "snmp_read_sp() sendto failed: %s", strerror(errno));
	 }
      }
   }
